/* exported config, connectDialogSettings, progressSettings */
var config = {
	useWebGL : false,
	debugMode : false,
	drawFPS : true,
	useHiRez : true,
	defaultPort : 9876,
	netSendInterval : 50,//limit outbound packets to 1 in every netSendInterval milliseconds
	protocolVersion : 3,
	useDegrees : true,
	useVSync : true,//use requestAnimationFrame when true, setTimeout( ..., 0 ) othervise. CocoonJS does not support RAF (check if so on the newer version)	
	doLogging : true,
	logPingAttempts : false,//very chatty
	//newsURL : "http://avioware.com/c172_news.html",
	useGradients : true,//@todo - move to progressSettings
	appName : "FSi C172",
	constantDrawLoop : true,//navigator.isCocoonJS,//draw stuff continuously even if not connected. needed in CocoonJS to avoid a bug. Not working currently?
	trimImageTransparency : false, useTrimmedCanvases : false,//experiments to trim the transparent portions of images, the code has bitrotten, canvas-texture drawing was slow on previous cocoonjs versions but now is ok => test
	doPingLoops : true,//constantly ping addresses that we've succesfully connected before. Fills the log with lots of text
	//disconnectPings : false,//disconnect an old ping when starting a connect, the old versions of cocoonjs did not like that, should be fixed in the new version :> test
	coldStartUI	: false,//start the UI immediately before fsi has initialized, loaded the images, etc
	httpPing : true,
	trimValuesToRange: false,//trim for c172???
	dontExtrapolateValues: false,//values are extrapolated from the last two known samples. Done once after a new data arrives
	dontConvergeValues: false,//the values have inertia and converge to a new value gradually. Done once per instrument after new data arrives and does not affect the extrapolation
},
connectDialogSettings = {
	defaultPort : config.defaultPort,
	useInputDialog: true,
	newsURL:  "http://avioware.com/news_android.html",
	debugMode: config.debugMode,
	doLogging: config.doLogging,
	newsConnectCount: 3
};
