/* global window, document, Cocoon, localStorage, XMLHttpRequest, b64_sha1 */
/* jshint curly: false */
var isCocoonJS,//window.location.hash == '#cocoon', //( window.self === window.top ),//the desktop version embeds the ui in iframe
	settings,
	isFSIReady = false,
	changedAutoValue,
	container, connectAddr, connectButton, addressLine, serverList, closeX, autoCheckbox, connected = false,
	connectedAddress, newsFrame,
	pingConnectAddress = null;

function onMessage(e) {
	output("(" + new Date().getTime() + ") UI: Received message, command=" + e.data.command + ", value=" + JSON.stringify(e.data.value));
	switch (e.data.command) {
	case "setaddr": //called only once at startup
		connectAddr.value = e.data.value;
		if (e.data.value !== "") {
			addServerItem(e.data.value);
			activateServerItem(e.data.value, false);
			onChangeAddress(e.data.value);
		} else
			onChangeAddress("");
		break;
	case "ready":
		isFSIReady = true;
		settings = e.data.value;
		initSettings();
		onChangeAddress(connectAddr.value);
		if( typeof changedAutoValue !== "undefined" )
			sendMessage('auto', changedAutoValue);	
		if( !settings.noAutoconnect && (autoCheckbox.checked || settings.reconnectOnStart) )
			clickConnectIfValid(true);
		break;
	case "reload-ui":
		reloadUI = true;
		//isFSIReady = true;
		break;
	case "auto":
		autoCheckbox.checked = e.data.value;
		pingConnectAddress = null;
		break;
	case "connect":
		connected = true;
		connectedAddress = e.data.value.address;
		activateServerItem(connectedAddress, true, e.data.value.serverName);
		closeX.style.display = 'block';
		//setStateIsConnecting( e.data.value, false );//connected => not connecting
		clearStatesIsConnecting();
		setStateConnected(connectedAddress, true);
		pingConnectAddress = null;
		//output( "connect case time =" + ( new Date().getTime()-t) );
		var count = localStorage.getItem("newsConnectCounter");
		localStorage.newsConnectCounter  = ( count===null )? 1 : ( parseInt(count)+1 );
		break;
	case "reconnect":
		setStateIsConnecting(e.data.value, true);
		//pingConnectAddress = null;
		//break;-no break
	case "disconnect":
		connected = false;
		if(e.data.command!="reconnect")
			setStateConnected(e.data.value, false);
		activateServerItem(e.data.value, false);
		closeX.style.display = 'none';
		pingConnectAddress = null;
		break;
	case "ping-ok":
		addServerItem(e.data.value.address, e.data.value.serverName, e.data.value.flightSim); //will also activate it
		activateServerItem(e.data.value.address, true);
		if (!e.data.value.connected && autoCheckbox.checked) {
			if (pingConnectAddress) {
				//we're already trying to connect to a pinged address
				if (pingConnectAddress == e.data.value.address)
					pingConnectAddress = null; //a second ping-ok to the same address and still no success... Give the next ping a chance
			} else {
				//auto-connect to this address
				pingConnectAddress = e.data.value.address;
				connectAddr.value = e.data.value.address;
				onChangeAddress(e.data.value.address);
				onClickConnect(false, true);
			}
		} else
			pingConnectAddress = null;
		break;
	case "ping-fail":
		if (e.data.value == pingConnectAddress)
			pingConnectAddress = null;
		activateServerItem(e.data.value, false);
		break;
	}
}

function sendMessage(comm, val) {
	//output( "cocosend: " + comm + "  " + val );
	if (!isCocoonJS)
		window.top.postMessage({
			command: comm,
			value: val
		}, '*');
	else {
		var t = new Date().getTime();
		Cocoon.App.forwardAsync("WebViewUI.onMessage('" + comm + (val === undefined ? "'" : ("'," + JSON.stringify(val))) + ");");
		output("(" + new Date().getTime() + ") UI:SendMessage done:" + comm + ",val=" + JSON.stringify(val) + ", t=" + (new Date().getTime() - t));
	}
}

function getListItem(selector, text) {
	var list = document.body.querySelectorAll(selector);
	for (var i = 0; i < list.length; i++) {
		if (list[i].querySelector("span").textContent == text) {
			return list[i];
		}
	}
}

function getServerItemHTML(addr, serverName) {
	return "<span>" + addr + "</span>" + (serverName ? ("<span>[&nbsp;" + serverName + "&nbsp;]</span>") : ""); // + "<button>Connect</button>";
}

function addServerItem(addr, serverName/*, flightSim*/) {
	if (addr === "" || (connected && addr == connectedAddress))
		return;
	var li = getListItem("#server_list>li", addr);
	if (li !== undefined) {
		//li.className = "";//remove class offline
		li.innerHTML = getServerItemHTML(addr, serverName);
		console.log('Change server list item for ' + addr);
	} else {
		//serverList.innerHTML += "<li>" + getServerItemHTML( addr, serverName ) + "</li>";
		//li = getListItem( "#server_list>li", addr );
		li = document.createElement('li');
		li.innerHTML = getServerItemHTML(addr, serverName);
		li.className = "offline";
		serverList.appendChild(li);
		console.log('Add server list item for ' + addr);
	}
	setServerItemEvents(li, addr);
	onChangeAddress(connectAddr.value); //not changed actually, but adding a new item may change the list visibility
}

function activateServerItem(addr, on, serverName) {
	var li = getListItem("#server_list>li", addr);
	if (li !== undefined) {
		var //isConnecting = li.className.indexOf("connecting")!=-1,//avoid using classList as it's not supported on older androids and iOS
			wasOffline = li.classList.contains('offline'); //li.className.indexOf("offline")!=-1;
		if (on) {
			if (wasOffline) {
				li.classList.remove('offline'); //li.className = isConnecting?"connecting":"";//not offline
				if (addr != connectAddr.value.trim())
					container.className = 'expanded'; //we have a new online ip address, expand the container
			}
		} else
			li.classList.add('offline'); //li.className = isConnecting?"offline connecting":"offline";
		if (addr == connectAddr.value.trim())
			connectAddr.className = li.className + ' dropdown'; //copy the class from the list item
		console.log("activate " + addr + " : " + li.className);
		li.innerHTML = getServerItemHTML(addr, serverName);
		setServerItemEvents(li, addr);
	}
}

function setServerItemEvents(li, addr) {
	li.onclick = function () {
		connectAddr.value = addr;
		onChangeAddress(addr);
	};
	/*li.getElementsByTagName("button")[0].onclick = function(){
		connectAddr.value = addr;
		onChangeAddress( addr );
		onClickConnect();
	};*/
}

function setStateIsConnecting(addr, on) {
	if (on)
		clearStatesIsConnecting();
	var li = getListItem("#server_list>li", addr);
	if (li !== undefined) {
		var isOffline = li.className.indexOf("offline") != -1; //avoid using classList as it's not supported on older androids and iOS
		if (on)
			li.className = isOffline ? "connecting offline" : "connecting";
		else
			li.className = isOffline ? "offline" : "";
		if (addr == connectAddr.value.trim())
			connectAddr.className = li.className + ' dropdown';
		console.log("setstaecon: " + li.className);
	}
}

function clearStatesIsConnecting() {
	var list = document.body.querySelectorAll("#server_list>li");
	for (var i = 0; i < list.length; i++)
		list[i].classList.remove("connecting");
	//if( list[i].className.indexOf("connecting")!=-1 )
	//	list[i].className = list[i].className.replace("connecting ","").replace(" connecting","").replace("connecting","");
	connectAddr.classList.remove("connecting"); //className = connectAddr.className.replace("connecting ","").replace(" connecting","").replace("connecting","");
	console.log("clearstaecon");
}

function setStateConnected(addr, on) {
	var li = getListItem("#server_list>li", addr);
	if (li !== undefined) {
		li.className = on ? "connected" : "";
		console.log("con: " + li.className);
		if (addr == connectAddr.value.trim())
			connectAddr.className = li.className + ' dropdown'; //copy the list item class
	}
}

function onChangeAddress(addr) {
	addr = trimAddress(addr);
	//if there is only one address and it's the same as the one in the input field - hide the list
	var list = document.body.querySelectorAll("#server_list>li");
	if (list.length === 0 || (list.length == 1 && list[0].querySelector("span").textContent == addr)) {
		//the list is empty or the only IP address in it is the current one
		serverList.style.display = "none"; //hide the list
		if (list.length == 1) {
			addressLine.className = ""; //4 rounded corners
			connectAddr.className = list[0].className; //copy the address input classNames from the list item classNames
			console.log("copyclass (1 item): " + list[0].className);
		} else {
			connectAddr.className = "offline";
			console.log("notinlist");
		}
	} else {
		serverList.style.display = "block"; //show the list															
		var li = getListItem("#server_list>li", addr);
		connectAddr.className = (li === undefined) ? "offline dropdown" : (li.className + " dropdown"); //make it offline or copy the list item class
		console.log("copyclass: " + ( (li === undefined ) ? "offline" : li.className));
	}
	connectButton.disabled = !isFSIReady || !validateAddress(addr);
}

function onClickConnect(dontUpdateState, autocon) {
	if (!autocon)
		pingConnectAddress = null;
	var addr = connectAddr.value;
	connectAddr.classList.add('connecting'); //className = connectAddr.className.indexOf('dropdown')!=-1?"connecting dropdown":"connecting";
	addr = addr.replace(/[!+()\]\[<>'"=;{}#&\\]/ig, ""); //sanitize addr to avoid exec vulnerabilitiy in cocoonjs sendMessage
	addr = trimAddress(addr);
	addServerItem(addr);
	sendMessage('connect', {
		address: validateAddress(addr) ? addr : "",
		autoConnecting: autocon
	});
	if (!dontUpdateState) {
		activateServerItem(addr, false);
		setStateIsConnecting(addr, true);
	}
}

function clickConnectIfValid(autocon) {
		if (validateAddress(connectAddr.value))
			onClickConnect(connected, autocon); //don't update the state when connected
	}
	/*
	 * Validate ipv4 address with an optional port number
	 */
function validateAddress(addr) {
	addr = trimAddress(addr);
	var portIndex = addr.lastIndexOf(":");
	if (portIndex != -1) {
		var port = addr.substring(addr.lastIndexOf(":") + 1, addr.length).trim();
		if (port === "" || (port >>> 0 !== parseFloat(port)))
			return false; //the port number must be a positive integer
		addr = addr.substring(0, portIndex);
	}
	//http://www.w3resource.com/javascript/form/ip-address-validation.php
	if (/^(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$/.test(addr));
	return true;
	//check hostname : http://stackoverflow.com/questions/106179/regular-expression-to-match-hostname-or-ip-address
	//return (/^([a-zA-Z0-9]|[a-zA-Z0-9][a-zA-Z0-9\-]{0,61}[a-zA-Z0-9])(\.([a-zA-Z0-9]|[a-zA-Z0-9][a-zA-Z0-9\-]{0,61}[a-zA-Z0-9]))*$/.test(addr));

}

function trimAddress(addr) {
	addr = addr.trim();
	if (addr.charAt(addr.length - 1) == ':') {
		addr = addr.substring(0, addr.length - 1); //addresses ending with : are considered valid
		addr = addr.trim();
	}
	return addr;
}

function initSettings(){
	output( JSON.stringify(settings) );
	
	document.getElementById("port_number").innerHTML = settings.defaultPort;
	if (settings.debugMode) {
		document.getElementById("demo").setAttribute("style", "");
		document.getElementById("demo_text").setAttribute("style", "");
		document.getElementById("reset_news").setAttribute("style", "");
	}
	
	if (!settings.useInputDialog || !isCocoonJS)
		connectAddr.removeAttribute('readonly');
	else {
		connectAddr.onclick = function (event) {
			//console.log( event.x - connectAddr.offsetLeft );
			console.log(connectAddr.offsetWidth - event.layerX);
			if (connectAddr.offsetWidth - event.layerX < 24) {
				//clicked the expand/collapse arrow
				/*if( serverList.style.display != "none" )
					serverList.style.display = "none";
				else
					serverList.style.display = "block";*/
				container.classList.toggle('expanded'); //className = container.className=='expanded'?'':'expanded';
			} else {
				//@todo - store the texts in a separate file
				Cocoon.Dialog.prompt({
					title: "Server Address",
					message: "Enter the server IP address",
					text: this.value,
					confirmText: "Connect"
				}, {
					success: function (text) {
						//onChangeAddress( this.value );
						if (!validateAddress(text))
							alert("Please enter a valid address.");
						else {
							connectAddr.value = text;
							onClickConnect();
						}
					},
					cancel: function () {}
				});
			}
		};
	}
	
	if( settings.debugMode ){
		window.setTimeout( function(){
			checkForNews();
		},1000);
	}
	else
		checkForNews();
}

function checkForNews(){
	var xmlhttp = new XMLHttpRequest();
	xmlhttp.onreadystatechange = function () {
		output( "Load news, readyState=" + xmlhttp.readyState +", status=" + xmlhttp.status );
		if (xmlhttp.readyState == 4 && xmlhttp.status == 200) {
			var sha1 = b64_sha1(xmlhttp.responseText);
			if (localStorage.getItem("newsHash") != sha1) {
				output("good news everyone");
				if(  localStorage.newsConnectCounter >= settings.newsConnectCount ){
					//localStorage.newsHash = sha1;
					document.getElementById('news').setAttribute("style", "");
					document.getElementById('connect').setAttribute("style", "display:none");
					var doc = newsFrame.contentDocument;
					doc.open();
					doc.writeln(xmlhttp.responseText);
					doc.close();
					sendMessage("show-news",true);
					newsFrame.contentDocument.getElementsByClassName("button")[0].onclick = function () {
						localStorage.newsHash = sha1;
						document.getElementById('news').setAttribute("style", "display:none");
						document.getElementById('connect').setAttribute("style", "");
						sendMessage("show-news",false);
					};
				}
			}
		}
	};
	xmlhttp.open("GET", settings.newsURL, true);
	xmlhttp.send();
}

window.addEventListener("message",function(e){
	 var data = e[ e.message ? 'message' : 'data' ];
	 if( data && data.type=="link" && data.url )
		sendMessage("open-url",data.url)
},false);

window.addEventListener("load", function () {
	
	/*var uri = window.location.href;
	uri = uri.substring(uri.indexOf("?") + 1, uri.length);
	uri.replace(
		new RegExp("([^?=&]+)(=([^&]*))?", "g"),
		function ($0, $1, $2, $3) {
			if( $3=="true" )
				settings[$1] = true;
			else if( $3=="false" )
				settings[$1] = false;
			else
				settings[$1] = decodeURIComponent($3);
		}
	);*/
	isCocoonJS = window.location.hash!='#iframe';
	

	//try{
	container = document.getElementById("connect_container");
	autoCheckbox = document.getElementById("auto");
	connectAddr = document.getElementById("connect_addr");
	connectButton = document.getElementById("connect_button");
	addressLine = document.getElementById('address_line');
	serverList = document.getElementById('server_list');
	closeX = document.getElementById('close');
	newsFrame = document.getElementById('news_frame');
	
	//initSettings();

	if (!isCocoonJS)
		window.addEventListener("message", onMessage, false);

	sendMessage('init');

	connectButton.onclick = function () {
		onClickConnect();
	};

	closeX.onclick = function () {
		//container.style.display = "none";
		sendMessage('hide-ui');
	};

	autoCheckbox.onclick = function () {
		if (isFSIReady) {
			sendMessage('auto', this.checked);
			if (this.checked)
				clickConnectIfValid(true);
			else if (!connected)
				sendMessage('connect', {
					address: "",
					autoConnecting: true
				});

		} else
			changedAutoValue = this.checked; //will do the above code from message "ready"
	};

	document.getElementById("demo").onclick = function () {
		sendMessage('demo', this.checked);
	};

	connectAddr.addEventListener('input', function () {
		onChangeAddress(this.value);
	}, false);

	document.getElementById('reset_news').onclick = function () {
		localStorage.newsHash = "Reset";
	};
});

function output(message) {
	if (settings && settings.doLogging) {
		if (isCocoonJS) {
			//due to a bug in cocoonjs the following call takes 5 seconds:
			//Cocoon.App.forwardAsync("console.log('" + message + "');");
			console.log(message);
		} else
			console.log(message);
	}
}