var netMessageACK = {//for the test data, with net connection this is sent by the server
	command: NETCOMMAND_Init,
	server_name: "geleserve",
	flight_sim: "XPlane 10 / PC", 
	server_agent: "FSi Server/2.09 (Windows NT 6.2; bg)"
};

var messageNo, simulateStillInstruments, stillFrames=25;
function netSimulate(){
	netInitiateDisconnect();//disconnect in case anything is connected
	if( simulateStillInstruments && netSIDataDump.length==0 ){
		//create a copy of netDataDump where the instruments from 'stillInstruments' change once in every 'stillFrames' (net frames that is)
		for( var i=0; i<netDataDump.length; i++ ){
			netSIDataDump.push( JSON.parse(JSON.stringify(netDataDump[i])) );
			for( var j=0; j<stillInstruments.length; j++ )
				netSIDataDump[i][stillInstruments[j]] = netDataDump[Math.floor(i/stillFrames)][stillInstruments[j]]; 
		}
	}
	messageNo = undefined;
	netSimulateLoop();
}

var timeOfDay = DP_DAY;
function netSimulateLoop(){	
	if( activeConnectionData )
		return;	
	var data, state;
	if( messageNo===undefined ){
		//imitate an acknowledge message from the server
		data = netMessageACK;
		state = NETSTATE_Init;
		messageNo = 0;
	}
	else{
		state = NETSTATE_Opened;		
		data = simulateStillInstruments? netSIDataDump[messageNo] : netDataDump[messageNo];
		var t = new Date();
		data.local_time = t.getHours()*60*60 + t.getMinutes()*60 + t.getSeconds();
		data.zulu_time = data.local_time + 120*60;			
		if( (t.getSeconds()%10)==0 )
			timeOfDay = DP_DAY;
		else if( ((t.getSeconds()+5)%10)==0 )
			timeOfDay = DP_NIGHT;
		data.time_of_day = timeOfDay;
		
		data.server_time = Math.floor(new Date().getTime());

		messageNo = (netDataDump.length-1==messageNo)? 0:messageNo+1;//cycle to the next messages
	}	
	netProcessMessage( null, state, "", data );
	                                              
	window.setTimeout(netSimulateLoop, 100 );//process a new message in 100ms	
}

var netSIDataDump = [];//used for the test with still instruments						
var netDataDump = [
{ whiskey_compass: 0.153153, ai_pitch: 0.102102, ai_bank: 0.153153, ai_bars_position: 0.100000, caged: 0, ai_fail: 0, indicated_airspeed: 10.000000, airspeed_calibration_angle: 0.047124, airspeed_fail: 0, indicated_altitude: 100.000000, kohlsman_setting: 28.000000, altitude_fail: 0, vertical_speed: 205.000000, vertical_fail: 0, turn_coordinator_bank: 0.039270, turn_coordinator_ball: 6, plane_heading_magnetic: 0.153153, autopilot_heading_magnetic: 6.283185, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 0.153153, nav1_cdi: 6, nav1_gsi: 6, nav1_to_from: 0, nav1_gs_flag: 0, nav_fail: 0, nav2_available: 0, nav2_obs: 0.153153, nav2_cdi: 6, nav2_to_from: 0, adf1_radial: 0.153153, adf1_card: 0.153153, adf_fail: 0, engine_rpm: 87, engine_elapsed_time: 9999.000000, engine_instruments_fail: 0, engine_oil_temp: 90.000000, engine_oil_pressure: 3.000000, engine_egt: 600.000000, engine_fuel_flow: 0.525000, fuel_qty_left_tank: 0.650000, fuel_qty_right_tank: 0.650000, fuel_indicator_fail: 0, vacuum: 3.000000, vacuum_fail: 0, amp: 3.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:0, low_vac_l:0, low_vac_r:0, low_voltage:0 },
{ whiskey_compass: 0.306305, ai_pitch: 0.204204, ai_bank: 0.306305, ai_bars_position: 0.200000, caged: 0, ai_fail: 0, indicated_airspeed: 20.000000, airspeed_calibration_angle: 0.094247, airspeed_fail: 0, indicated_altitude: 200.000000, kohlsman_setting: 28.035000, altitude_fail: 0, vertical_speed: 410.000000, vertical_fail: 0, turn_coordinator_bank: 0.078540, turn_coordinator_ball: 12, plane_heading_magnetic: 0.306305, autopilot_heading_magnetic: 6.130033, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 0.306305, nav1_cdi: 12, nav1_gsi: 12, nav1_to_from: 0, nav1_gs_flag: 0, nav_fail: 0, nav2_available: 0, nav2_obs: 0.306305, nav2_cdi: 12, nav2_to_from: 0, adf1_radial: 0.306305, adf1_card: 0.306305, adf_fail: 0, engine_rpm: 174, engine_elapsed_time: 9999.200000, engine_instruments_fail: 0, engine_oil_temp: 93.875000, engine_oil_pressure: 6.000000, engine_egt: 630.000000, engine_fuel_flow: 1.050000, fuel_qty_left_tank: 1.300000, fuel_qty_right_tank: 1.300000, fuel_indicator_fail: 0, vacuum: 3.100000, vacuum_fail: 0, amp: 6.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:0, low_vac_l:0, low_vac_r:0, low_voltage:0 },
{ whiskey_compass: 0.459458, ai_pitch: 0.306305, ai_bank: 0.459458, ai_bars_position: 0.300000, caged: 0, ai_fail: 0, indicated_airspeed: 30.000000, airspeed_calibration_angle: 0.141371, airspeed_fail: 0, indicated_altitude: 300.000000, kohlsman_setting: 28.070000, altitude_fail: 0, vertical_speed: 615.000000, vertical_fail: 0, turn_coordinator_bank: 0.117810, turn_coordinator_ball: 18, plane_heading_magnetic: 0.459458, autopilot_heading_magnetic: 5.976880, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 0.459458, nav1_cdi: 18, nav1_gsi: 18, nav1_to_from: 0, nav1_gs_flag: 0, nav_fail: 0, nav2_available: 0, nav2_obs: 0.459458, nav2_cdi: 18, nav2_to_from: 0, adf1_radial: 0.459458, adf1_card: 0.459458, adf_fail: 0, engine_rpm: 261, engine_elapsed_time: 9999.400000, engine_instruments_fail: 0, engine_oil_temp: 97.750000, engine_oil_pressure: 9.000000, engine_egt: 660.000000, engine_fuel_flow: 1.575000, fuel_qty_left_tank: 1.950000, fuel_qty_right_tank: 1.950000, fuel_indicator_fail: 0, vacuum: 3.200000, vacuum_fail: 0, amp: 9.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:0, low_vac_l:0, low_vac_r:0, low_voltage:0 },
{ whiskey_compass: 0.612611, ai_pitch: 0.408407, ai_bank: 0.612611, ai_bars_position: 0.400000, caged: 0, ai_fail: 0, indicated_airspeed: 40.000000, airspeed_calibration_angle: 0.188495, airspeed_fail: 0, indicated_altitude: 400.000000, kohlsman_setting: 28.105000, altitude_fail: 0, vertical_speed: 820.000000, vertical_fail: 0, turn_coordinator_bank: 0.157080, turn_coordinator_ball: 24, plane_heading_magnetic: 0.612611, autopilot_heading_magnetic: 5.823727, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 0.612611, nav1_cdi: 24, nav1_gsi: 24, nav1_to_from: 0, nav1_gs_flag: 0, nav_fail: 0, nav2_available: 0, nav2_obs: 0.612611, nav2_cdi: 24, nav2_to_from: 0, adf1_radial: 0.612611, adf1_card: 0.612611, adf_fail: 0, engine_rpm: 348, engine_elapsed_time: 9999.600000, engine_instruments_fail: 0, engine_oil_temp: 101.625000, engine_oil_pressure: 12.000000, engine_egt: 690.000000, engine_fuel_flow: 2.100000, fuel_qty_left_tank: 2.600000, fuel_qty_right_tank: 2.600000, fuel_indicator_fail: 0, vacuum: 3.300000, vacuum_fail: 0, amp: 12.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:0, low_vac_l:0, low_vac_r:0, low_voltage:0 },
{ whiskey_compass: 0.765763, ai_pitch: 0.510509, ai_bank: 0.765763, ai_bars_position: 0.500000, caged: 0, ai_fail: 0, indicated_airspeed: 50.000000, airspeed_calibration_angle: 0.235618, airspeed_fail: 0, indicated_altitude: 500.000000, kohlsman_setting: 28.140000, altitude_fail: 0, vertical_speed: 1025.000000, vertical_fail: 0, turn_coordinator_bank: 0.196350, turn_coordinator_ball: 30, plane_heading_magnetic: 0.765763, autopilot_heading_magnetic: 5.670575, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 0.765763, nav1_cdi: 30, nav1_gsi: 30, nav1_to_from: 0, nav1_gs_flag: 0, nav_fail: 0, nav2_available: 0, nav2_obs: 0.765763, nav2_cdi: 30, nav2_to_from: 0, adf1_radial: 0.765763, adf1_card: 0.765763, adf_fail: 0, engine_rpm: 435, engine_elapsed_time: 9999.800000, engine_instruments_fail: 0, engine_oil_temp: 105.500000, engine_oil_pressure: 15.000000, engine_egt: 720.000000, engine_fuel_flow: 2.625000, fuel_qty_left_tank: 3.250000, fuel_qty_right_tank: 3.250000, fuel_indicator_fail: 0, vacuum: 3.400000, vacuum_fail: 0, amp: 15.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:0, low_vac_l:0, low_vac_r:0, low_voltage:0},
{ whiskey_compass: 0.918916, ai_pitch: 0.612611, ai_bank: 0.918916, ai_bars_position: 0.600000, caged: 0, ai_fail: 0, indicated_airspeed: 60.000000, airspeed_calibration_angle: 0.282742, airspeed_fail: 0, indicated_altitude: 600.000000, kohlsman_setting: 28.175000, altitude_fail: 0, vertical_speed: 1230.000000, vertical_fail: 0, turn_coordinator_bank: 0.235619, turn_coordinator_ball: 36, plane_heading_magnetic: 0.918916, autopilot_heading_magnetic: 5.517422, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 0.918916, nav1_cdi: 36, nav1_gsi: 36, nav1_to_from: 0, nav1_gs_flag: 0, nav_fail: 0, nav2_available: 0, nav2_obs: 0.918916, nav2_cdi: 36, nav2_to_from: 0, adf1_radial: 0.918916, adf1_card: 0.918916, adf_fail: 0, engine_rpm: 522, engine_elapsed_time: 10000.000000, engine_instruments_fail: 0, engine_oil_temp: 109.375000, engine_oil_pressure: 18.000000, engine_egt: 750.000000, engine_fuel_flow: 3.150000, fuel_qty_left_tank: 3.900000, fuel_qty_right_tank: 3.900000, fuel_indicator_fail: 0, vacuum: 3.500000, vacuum_fail: 0, amp: 18.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:0, low_vac_l:0, low_vac_r:0, low_voltage:0},
{ whiskey_compass: 1.072068, ai_pitch: 0.714712, ai_bank: 1.072068, ai_bars_position: 0.700000, caged: 0, ai_fail: 0, indicated_airspeed: 70.000000, airspeed_calibration_angle: 0.329866, airspeed_fail: 0, indicated_altitude: 700.000000, kohlsman_setting: 28.210000, altitude_fail: 0, vertical_speed: 1435.000000, vertical_fail: 0, turn_coordinator_bank: 0.274889, turn_coordinator_ball: 42, plane_heading_magnetic: 1.072068, autopilot_heading_magnetic: 5.364269, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 1.072068, nav1_cdi: 42, nav1_gsi: 42, nav1_to_from: 0, nav1_gs_flag: 0, nav_fail: 0, nav2_available: 0, nav2_obs: 1.072068, nav2_cdi: 42, nav2_to_from: 0, adf1_radial: 1.072068, adf1_card: 1.072068, adf_fail: 0, engine_rpm: 609, engine_elapsed_time: 10000.200000, engine_instruments_fail: 0, engine_oil_temp: 113.250000, engine_oil_pressure: 21.000000, engine_egt: 780.000000, engine_fuel_flow: 3.675000, fuel_qty_left_tank: 4.550000, fuel_qty_right_tank: 4.550000, fuel_indicator_fail: 0, vacuum: 3.600000, vacuum_fail: 0, amp: 21.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:0, low_vac_l:0, low_vac_r:0, low_voltage:0},
{ whiskey_compass: 1.225221, ai_pitch: 0.816814, ai_bank: 1.225221, ai_bars_position: 0.800000, caged: 0, ai_fail: 0, indicated_airspeed: 80.000000, airspeed_calibration_angle: 0.376989, airspeed_fail: 0, indicated_altitude: 800.000000, kohlsman_setting: 28.245000, altitude_fail: 0, vertical_speed: 1640.000000, vertical_fail: 0, turn_coordinator_bank: 0.314159, turn_coordinator_ball: 48, plane_heading_magnetic: 1.225221, autopilot_heading_magnetic: 5.211117, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 1.225221, nav1_cdi: 48, nav1_gsi: 48, nav1_to_from: 0, nav1_gs_flag: 0, nav_fail: 0, nav2_available: 0, nav2_obs: 1.225221, nav2_cdi: 48, nav2_to_from: 0, adf1_radial: 1.225221, adf1_card: 1.225221, adf_fail: 0, engine_rpm: 696, engine_elapsed_time: 10000.400000, engine_instruments_fail: 0, engine_oil_temp: 117.125000, engine_oil_pressure: 24.000000, engine_egt: 810.000000, engine_fuel_flow: 4.200000, fuel_qty_left_tank: 5.200000, fuel_qty_right_tank: 5.200000, fuel_indicator_fail: 0, vacuum: 3.700000, vacuum_fail: 0, amp: 24.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:0, low_vac_l:0, low_vac_r:0, low_voltage:0},
{ whiskey_compass: 1.378374, ai_pitch: 0.918916, ai_bank: 1.378374, ai_bars_position: 0.900000, caged: 0, ai_fail: 0, indicated_airspeed: 90.000000, airspeed_calibration_angle: 0.424113, airspeed_fail: 0, indicated_altitude: 900.000000, kohlsman_setting: 28.280000, altitude_fail: 0, vertical_speed: 1845.000000, vertical_fail: 0, turn_coordinator_bank: 0.353429, turn_coordinator_ball: 54, plane_heading_magnetic: 1.378374, autopilot_heading_magnetic: 5.057964, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 1.378374, nav1_cdi: 54, nav1_gsi: 54, nav1_to_from: 0, nav1_gs_flag: 0, nav_fail: 0, nav2_available: 0, nav2_obs: 1.378374, nav2_cdi: 54, nav2_to_from: 0, adf1_radial: 1.378374, adf1_card: 1.378374, adf_fail: 0, engine_rpm: 783, engine_elapsed_time: 10000.600000, engine_instruments_fail: 0, engine_oil_temp: 121.000000, engine_oil_pressure: 27.000000, engine_egt: 840.000000, engine_fuel_flow: 4.725000, fuel_qty_left_tank: 5.850000, fuel_qty_right_tank: 5.850000, fuel_indicator_fail: 0, vacuum: 3.800000, vacuum_fail: 0, amp: 27.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:0, low_vac_l:0, low_vac_r:0, low_voltage:0},
{ whiskey_compass: 1.531526, ai_pitch: -1.047198, ai_bank: 1.531526, ai_bars_position: 1.000000, caged: 0, ai_fail: 0, indicated_airspeed: 100.000000, airspeed_calibration_angle: 0.471237, airspeed_fail: 0, indicated_altitude: 1000.000000, kohlsman_setting: 28.315000, altitude_fail: 0, vertical_speed: 2050.000000, vertical_fail: 0, turn_coordinator_bank: 0.392699, turn_coordinator_ball: 60, plane_heading_magnetic: 1.531526, autopilot_heading_magnetic: 4.904812, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 1.531526, nav1_cdi: 60, nav1_gsi: 60, nav1_to_from: 1, nav1_gs_flag: 0, nav_fail: 0, nav2_available: 0, nav2_obs: 1.531526, nav2_cdi: 60, nav2_to_from: 1, adf1_radial: 1.531526, adf1_card: 1.531526, adf_fail: 0, engine_rpm: 870, engine_elapsed_time: 10000.800000, engine_instruments_fail: 0, engine_oil_temp: 124.875000, engine_oil_pressure: 30.000000, engine_egt: 870.000000, engine_fuel_flow: 5.250000, fuel_qty_left_tank: 6.500000, fuel_qty_right_tank: 6.500000, fuel_indicator_fail: 0, vacuum: 3.900000, vacuum_fail: 0, amp: 30.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:0, low_vac_l:0, low_vac_r:0, low_voltage:0 },
{ whiskey_compass: 1.684679, ai_pitch: -0.945096, ai_bank: 1.684679, ai_bars_position: -1.000000, caged: 0, ai_fail: 0, indicated_airspeed: 110.000000, airspeed_calibration_angle: -0.471237, airspeed_fail: 0, indicated_altitude: 1100.000000, kohlsman_setting: 28.350000, altitude_fail: 0, vertical_speed: -2050.000000, vertical_fail: 0, turn_coordinator_bank: 0.431969, turn_coordinator_ball: 66, plane_heading_magnetic: 1.684679, autopilot_heading_magnetic: 4.751659, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 1.684679, nav1_cdi: 66, nav1_gsi: 66, nav1_to_from: 1, nav1_gs_flag: 0, nav_fail: 0, nav2_available: 0, nav2_obs: 1.684679, nav2_cdi: 66, nav2_to_from: 1, adf1_radial: 1.684679, adf1_card: 1.684679, adf_fail: 0, engine_rpm: 957, engine_elapsed_time: 9999.000000, engine_instruments_fail: 0, engine_oil_temp: 128.750000, engine_oil_pressure: 33.000000, engine_egt: 900.000000, engine_fuel_flow: 5.775000, fuel_qty_left_tank: 7.150000, fuel_qty_right_tank: 7.150000, fuel_indicator_fail: 0, vacuum: 4.000000, vacuum_fail: 0, amp: 33.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:0, low_vac_l:0, low_vac_r:0, low_voltage:0},
{ whiskey_compass: 1.837832, ai_pitch: -0.842994, ai_bank: 1.837832, ai_bars_position: -0.900000, caged: 0, ai_fail: 0, indicated_airspeed: 120.000000, airspeed_calibration_angle: -0.424113, airspeed_fail: 0, indicated_altitude: 1200.000000, kohlsman_setting: 28.385000, altitude_fail: 0, vertical_speed: -1845.000000, vertical_fail: 0, turn_coordinator_bank: 0.471239, turn_coordinator_ball: 72, plane_heading_magnetic: 1.837832, autopilot_heading_magnetic: 4.598506, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 1.837832, nav1_cdi: 72, nav1_gsi: 72, nav1_to_from: 1, nav1_gs_flag: 0, nav_fail: 0, nav2_available: 0, nav2_obs: 1.837832, nav2_cdi: 72, nav2_to_from: 1, adf1_radial: 1.837832, adf1_card: 1.837832, adf_fail: 0, engine_rpm: 1044, engine_elapsed_time: 9999.200000, engine_instruments_fail: 0, engine_oil_temp: 132.625000, engine_oil_pressure: 36.000000, engine_egt: 930.000000, engine_fuel_flow: 6.300000, fuel_qty_left_tank: 7.800000, fuel_qty_right_tank: 7.800000, fuel_indicator_fail: 0, vacuum: 4.100000, vacuum_fail: 0, amp: 36.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:0, low_vac_l:0, low_vac_r:0, low_voltage:0},
{ whiskey_compass: 1.990984, ai_pitch: -0.740892, ai_bank: 1.990984, ai_bars_position: -0.800000, caged: 0, ai_fail: 0, indicated_airspeed: 130.000000, airspeed_calibration_angle: -0.376989, airspeed_fail: 0, indicated_altitude: 1300.000000, kohlsman_setting: 28.420000, altitude_fail: 0, vertical_speed: -1640.000000, vertical_fail: 0, turn_coordinator_bank: 0.510509, turn_coordinator_ball: 78, plane_heading_magnetic: 1.990984, autopilot_heading_magnetic: 4.445354, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 1.990984, nav1_cdi: 78, nav1_gsi: 78, nav1_to_from: 1, nav1_gs_flag: 0, nav_fail: 0, nav2_available: 0, nav2_obs: 1.990984, nav2_cdi: 78, nav2_to_from: 1, adf1_radial: 1.990984, adf1_card: 1.990984, adf_fail: 0, engine_rpm: 1131, engine_elapsed_time: 9999.400000, engine_instruments_fail: 0, engine_oil_temp: 136.500000, engine_oil_pressure: 39.000000, engine_egt: 960.000000, engine_fuel_flow: 6.825000, fuel_qty_left_tank: 8.450000, fuel_qty_right_tank: 8.450000, fuel_indicator_fail: 0, vacuum: 4.200000, vacuum_fail: 0, amp: 39.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:0, low_vac_l:0, low_vac_r:0, low_voltage:0},
{ whiskey_compass: 2.144137, ai_pitch: -0.638791, ai_bank: 2.144137, ai_bars_position: -0.700000, caged: 0, ai_fail: 0, indicated_airspeed: 140.000000, airspeed_calibration_angle: -0.329866, airspeed_fail: 0, indicated_altitude: 1400.000000, kohlsman_setting: 28.455000, altitude_fail: 0, vertical_speed: -1435.000000, vertical_fail: 0, turn_coordinator_bank: 0.549779, turn_coordinator_ball: 84, plane_heading_magnetic: 2.144137, autopilot_heading_magnetic: 4.292201, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 2.144137, nav1_cdi: 84, nav1_gsi: 84, nav1_to_from: 1, nav1_gs_flag: 0, nav_fail: 0, nav2_available: 0, nav2_obs: 2.144137, nav2_cdi: 84, nav2_to_from: 1, adf1_radial: 2.144137, adf1_card: 2.144137, adf_fail: 0, engine_rpm: 1218, engine_elapsed_time: 9999.600000, engine_instruments_fail: 0, engine_oil_temp: 140.375000, engine_oil_pressure: 42.000000, engine_egt: 990.000000, engine_fuel_flow: 7.350000, fuel_qty_left_tank: 9.100000, fuel_qty_right_tank: 9.100000, fuel_indicator_fail: 0, vacuum: 4.300000, vacuum_fail: 0, amp: 42.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:0, low_vac_l:0, low_vac_r:0, low_voltage:0},
{ whiskey_compass: 2.297290, ai_pitch: -0.536689, ai_bank: 2.297290, ai_bars_position: -0.600000, caged: 0, ai_fail: 0, indicated_airspeed: 150.000000, airspeed_calibration_angle: -0.282742, airspeed_fail: 0, indicated_altitude: 1500.000000, kohlsman_setting: 28.490000, altitude_fail: 0, vertical_speed: -1230.000000, vertical_fail: 0, turn_coordinator_bank: 0.589049, turn_coordinator_ball: 90, plane_heading_magnetic: 2.297290, autopilot_heading_magnetic: 4.139048, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 2.297290, nav1_cdi: 90, nav1_gsi: 90, nav1_to_from: 1, nav1_gs_flag: 1, nav_fail: 0, nav2_available: 0, nav2_obs: 2.297290, nav2_cdi: 90, nav2_to_from: 1, adf1_radial: 2.297290, adf1_card: 2.297290, adf_fail: 0, engine_rpm: 1305, engine_elapsed_time: 9999.800000, engine_instruments_fail: 0, engine_oil_temp: 144.250000, engine_oil_pressure: 45.000000, engine_egt: 1020.000000, engine_fuel_flow: 7.875000, fuel_qty_left_tank: 9.750000, fuel_qty_right_tank: 9.750000, fuel_indicator_fail: 0, vacuum: 4.400000, vacuum_fail: 0, amp: 45.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:0, low_vac_l:0, low_vac_r:0, low_voltage:0},
{ whiskey_compass: 2.450442, ai_pitch: -0.434587, ai_bank: 2.450442, ai_bars_position: -0.500000, caged: 0, ai_fail: 0, indicated_airspeed: 160.000000, airspeed_calibration_angle: -0.235618, airspeed_fail: 0, indicated_altitude: 1600.000000, kohlsman_setting: 28.525000, altitude_fail: 0, vertical_speed: -1025.000000, vertical_fail: 0, turn_coordinator_bank: 0.628319, turn_coordinator_ball: 96, plane_heading_magnetic: 2.450442, autopilot_heading_magnetic: 3.985896, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 2.450442, nav1_cdi: 96, nav1_gsi: 96, nav1_to_from: 1, nav1_gs_flag: 1, nav_fail: 0, nav2_available: 0, nav2_obs: 2.450442, nav2_cdi: 96, nav2_to_from: 1, adf1_radial: 2.450442, adf1_card: 2.450442, adf_fail: 0, engine_rpm: 1392, engine_elapsed_time: 10000.000000, engine_instruments_fail: 0, engine_oil_temp: 148.125000, engine_oil_pressure: 48.000000, engine_egt: 1050.000000, engine_fuel_flow: 8.400000, fuel_qty_left_tank: 10.400000, fuel_qty_right_tank: 10.400000, fuel_indicator_fail: 0, vacuum: 4.500000, vacuum_fail: 0, amp: 48.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:0, low_vac_l:0, low_vac_r:0, low_voltage:0},
{ whiskey_compass: 2.603595, ai_pitch: -0.332485, ai_bank: 2.603595, ai_bars_position: -0.400000, caged: 0, ai_fail: 0, indicated_airspeed: 170.000000, airspeed_calibration_angle: -0.188495, airspeed_fail: 0, indicated_altitude: 1700.000000, kohlsman_setting: 28.560000, altitude_fail: 0, vertical_speed: -820.000000, vertical_fail: 0, turn_coordinator_bank: 0.667588, turn_coordinator_ball: 102, plane_heading_magnetic: 2.603595, autopilot_heading_magnetic: 3.832743, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 2.603595, nav1_cdi: 102, nav1_gsi: 102, nav1_to_from: 1, nav1_gs_flag: 1, nav_fail: 0, nav2_available: 0, nav2_obs: 2.603595, nav2_cdi: 102, nav2_to_from: 1, adf1_radial: 2.603595, adf1_card: 2.603595, adf_fail: 0, engine_rpm: 1479, engine_elapsed_time: 10000.200000, engine_instruments_fail: 0, engine_oil_temp: 152.000000, engine_oil_pressure: 51.000000, engine_egt: 1080.000000, engine_fuel_flow: 8.925000, fuel_qty_left_tank: 11.050000, fuel_qty_right_tank: 11.050000, fuel_indicator_fail: 0, vacuum: 4.600000, vacuum_fail: 0, amp: 51.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:0, low_vac_l:0, low_vac_r:0, low_voltage:0},
{ whiskey_compass: 2.756748, ai_pitch: -0.230383, ai_bank: 2.756748, ai_bars_position: -0.300000, caged: 0, ai_fail: 0, indicated_airspeed: 180.000000, airspeed_calibration_angle: -0.141371, airspeed_fail: 0, indicated_altitude: 1800.000000, kohlsman_setting: 28.595000, altitude_fail: 0, vertical_speed: -615.000000, vertical_fail: 0, turn_coordinator_bank: 0.706858, turn_coordinator_ball: 108, plane_heading_magnetic: 2.756748, autopilot_heading_magnetic: 3.679590, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 2.756748, nav1_cdi: 108, nav1_gsi: 108, nav1_to_from: 1, nav1_gs_flag: 1, nav_fail: 0, nav2_available: 0, nav2_obs: 2.756748, nav2_cdi: 108, nav2_to_from: 1, adf1_radial: 2.756748, adf1_card: 2.756748, adf_fail: 0, engine_rpm: 1566, engine_elapsed_time: 10000.400000, engine_instruments_fail: 0, engine_oil_temp: 155.875000, engine_oil_pressure: 54.000000, engine_egt: 1110.000000, engine_fuel_flow: 9.450000, fuel_qty_left_tank: 11.700000, fuel_qty_right_tank: 11.700000, fuel_indicator_fail: 0, vacuum: 4.700000, vacuum_fail: 0, amp: 54.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:0, low_vac_l:0, low_vac_r:0, low_voltage:1},
{ whiskey_compass: 2.909900, ai_pitch: -0.128282, ai_bank: 2.909900, ai_bars_position: -0.200000, caged: 0, ai_fail: 0, indicated_airspeed: 190.000000, airspeed_calibration_angle: -0.094247, airspeed_fail: 0, indicated_altitude: 1900.000000, kohlsman_setting: 28.630000, altitude_fail: 0, vertical_speed: -410.000000, vertical_fail: 0, turn_coordinator_bank: 0.746128, turn_coordinator_ball: 114, plane_heading_magnetic: 2.909900, autopilot_heading_magnetic: 3.526438, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 2.909900, nav1_cdi: 114, nav1_gsi: 114, nav1_to_from: 1, nav1_gs_flag: 1, nav_fail: 0, nav2_available: 0, nav2_obs: 2.909900, nav2_cdi: 114, nav2_to_from: 1, adf1_radial: 2.909900, adf1_card: 2.909900, adf_fail: 0, engine_rpm: 1653, engine_elapsed_time: 10000.600000, engine_instruments_fail: 0, engine_oil_temp: 159.750000, engine_oil_pressure: 57.000000, engine_egt: 1140.000000, engine_fuel_flow: 9.975000, fuel_qty_left_tank: 12.350000, fuel_qty_right_tank: 12.350000, fuel_indicator_fail: 0, vacuum: 4.800000, vacuum_fail: 0, amp: 57.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:0, low_vac_l:0, low_vac_r:0, low_voltage:1},
{ whiskey_compass: 3.063053, ai_pitch: -0.026180, ai_bank: -3.141593, ai_bars_position: -0.100000, caged: 0, ai_fail: 0, indicated_airspeed: 200.000000, airspeed_calibration_angle: -0.047124, airspeed_fail: 0, indicated_altitude: 2000.000000, kohlsman_setting: 28.665000, altitude_fail: 0, vertical_speed: -205.000000, vertical_fail: 0, turn_coordinator_bank: 0.785398, turn_coordinator_ball: 120, plane_heading_magnetic: 3.063053, autopilot_heading_magnetic: 3.373285, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 3.063053, nav1_cdi: 120, nav1_gsi: 120, nav1_to_from: 2, nav1_gs_flag: 1, nav_fail: 0, nav2_available: 0, nav2_obs: 3.063053, nav2_cdi: 120, nav2_to_from: 2, adf1_radial: 3.063053, adf1_card: 3.063053, adf_fail: 0, engine_rpm: 1740, engine_elapsed_time: 10000.800000, engine_instruments_fail: 0, engine_oil_temp: 163.625000, engine_oil_pressure: 60.000000, engine_egt: 1170.000000, engine_fuel_flow: 10.500000, fuel_qty_left_tank: 13.000000, fuel_qty_right_tank: 13.000000, fuel_indicator_fail: 0, vacuum: 4.900000, vacuum_fail: 0, amp: 60.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:0, low_vac_l:0, low_vac_r:0, low_voltage:1},
{ whiskey_compass: 3.216205, ai_pitch: 0.075922, ai_bank: -2.988440, ai_bars_position: -0.000000, caged: 0, ai_fail: 0, indicated_airspeed: 210.000000, airspeed_calibration_angle: -0.000000, airspeed_fail: 0, indicated_altitude: 2100.000000, kohlsman_setting: 28.700000, altitude_fail: 0, vertical_speed: 0.000000, vertical_fail: 0, turn_coordinator_bank: -0.785398, turn_coordinator_ball: 126, plane_heading_magnetic: 3.216205, autopilot_heading_magnetic: 3.220132, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 3.216205, nav1_cdi: 126, nav1_gsi: 126, nav1_to_from: 2, nav1_gs_flag: 1, nav_fail: 0, nav2_available: 0, nav2_obs: 3.216205, nav2_cdi: 126, nav2_to_from: 2, adf1_radial: 3.216205, adf1_card: 3.216205, adf_fail: 0, engine_rpm: 1827, engine_elapsed_time: 9999.000000, engine_instruments_fail: 0, engine_oil_temp: 167.500000, engine_oil_pressure: 63.000000, engine_egt: 1200.000000, engine_fuel_flow: 11.025000, fuel_qty_left_tank: 13.650000, fuel_qty_right_tank: 13.650000, fuel_indicator_fail: 0, vacuum: 5.000000, vacuum_fail: 0, amp: -60.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:0, low_vac_l:0, low_vac_r:0, low_voltage:1},
{ whiskey_compass: 3.369358, ai_pitch: 0.178024, ai_bank: -2.835287, ai_bars_position: 0.100000, caged: 0, ai_fail: 0, indicated_airspeed: 0.000000, airspeed_calibration_angle: 0.047124, airspeed_fail: 0, indicated_altitude: 2200.000000, kohlsman_setting: 28.735000, altitude_fail: 0, vertical_speed: 205.000000, vertical_fail: 0, turn_coordinator_bank: -0.746128, turn_coordinator_ball: -127, plane_heading_magnetic: 3.369358, autopilot_heading_magnetic: 3.066980, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 3.369358, nav1_cdi: -127, nav1_gsi: -127, nav1_to_from: 2, nav1_gs_flag: 1, nav_fail: 0, nav2_available: 0, nav2_obs: 3.369358, nav2_cdi: -127, nav2_to_from: 2, adf1_radial: 3.369358, adf1_card: 3.369358, adf_fail: 0, engine_rpm: 1914, engine_elapsed_time: 9999.200000, engine_instruments_fail: 0, engine_oil_temp: 171.375000, engine_oil_pressure: 66.000000, engine_egt: 1230.000000, engine_fuel_flow: 11.550000, fuel_qty_left_tank: 14.300000, fuel_qty_right_tank: 14.300000, fuel_indicator_fail: 0, vacuum: 5.100000, vacuum_fail: 0, amp: -57.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:0, low_vac_l:0, low_vac_r:0, low_voltage:1},
{ whiskey_compass: 3.522511, ai_pitch: 0.280125, ai_bank: -2.682135, ai_bars_position: 0.200000, caged: 0, ai_fail: 0, indicated_airspeed: 10.000000, airspeed_calibration_angle: 0.094247, airspeed_fail: 0, indicated_altitude: 2300.000000, kohlsman_setting: 28.770000, altitude_fail: 0, vertical_speed: 410.000000, vertical_fail: 0, turn_coordinator_bank: -0.706858, turn_coordinator_ball: -121, plane_heading_magnetic: 3.522511, autopilot_heading_magnetic: 2.913827, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 3.522511, nav1_cdi: -121, nav1_gsi: -121, nav1_to_from: 2, nav1_gs_flag: 1, nav_fail: 0, nav2_available: 0, nav2_obs: 3.522511, nav2_cdi: -121, nav2_to_from: 2, adf1_radial: 3.522511, adf1_card: 3.522511, adf_fail: 0, engine_rpm: 2001, engine_elapsed_time: 9999.400000, engine_instruments_fail: 0, engine_oil_temp: 175.250000, engine_oil_pressure: 69.000000, engine_egt: 1260.000000, engine_fuel_flow: 12.075000, fuel_qty_left_tank: 14.950000, fuel_qty_right_tank: 14.950000, fuel_indicator_fail: 0, vacuum: 5.200000, vacuum_fail: 0, amp: -54.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:0, low_vac_l:0, low_vac_r:0, low_voltage:1},
{ whiskey_compass: 3.675663, ai_pitch: 0.382227, ai_bank: -2.528982, ai_bars_position: 0.300000, caged: 0, ai_fail: 1, indicated_airspeed: 20.000000, airspeed_calibration_angle: 0.141371, airspeed_fail: 0, indicated_altitude: 2400.000000, kohlsman_setting: 28.805000, altitude_fail: 0, vertical_speed: 615.000000, vertical_fail: 0, turn_coordinator_bank: -0.667588, turn_coordinator_ball: -115, plane_heading_magnetic: 3.675663, autopilot_heading_magnetic: 2.760675, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 3.675663, nav1_cdi: -115, nav1_gsi: -115, nav1_to_from: 2, nav1_gs_flag: 1, nav_fail: 0, nav2_available: 0, nav2_obs: 3.675663, nav2_cdi: -115, nav2_to_from: 2, adf1_radial: 3.675663, adf1_card: 3.675663, adf_fail: 0, engine_rpm: 2088, engine_elapsed_time: 9999.600000, engine_instruments_fail: 0, engine_oil_temp: 179.125000, engine_oil_pressure: 72.000000, engine_egt: 1290.000000, engine_fuel_flow: 12.600000, fuel_qty_left_tank: 15.600000, fuel_qty_right_tank: 15.600000, fuel_indicator_fail: 0, vacuum: 5.300000, vacuum_fail: 0, amp: -51.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:0, low_vac_l:0, low_vac_r:0, low_voltage:1},
{ whiskey_compass: 3.828816, ai_pitch: 0.484329, ai_bank: -2.375829, ai_bars_position: 0.400000, caged: 0, ai_fail: 1, indicated_airspeed: 30.000000, airspeed_calibration_angle: 0.188495, airspeed_fail: 0, indicated_altitude: 2500.000000, kohlsman_setting: 28.840000, altitude_fail: 0, vertical_speed: 820.000000, vertical_fail: 0, turn_coordinator_bank: -0.628319, turn_coordinator_ball: -109, plane_heading_magnetic: 3.828816, autopilot_heading_magnetic: 2.607522, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 3.828816, nav1_cdi: -109, nav1_gsi: -109, nav1_to_from: 2, nav1_gs_flag: 1, nav_fail: 0, nav2_available: 0, nav2_obs: 3.828816, nav2_cdi: -109, nav2_to_from: 2, adf1_radial: 3.828816, adf1_card: 3.828816, adf_fail: 0, engine_rpm: 2175, engine_elapsed_time: 9999.800000, engine_instruments_fail: 0, engine_oil_temp: 183.000000, engine_oil_pressure: 75.000000, engine_egt: 1320.000000, engine_fuel_flow: 13.125000, fuel_qty_left_tank: 16.250000, fuel_qty_right_tank: 16.250000, fuel_indicator_fail: 0, vacuum: 5.400000, vacuum_fail: 0, amp: -48.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:0, low_vac_l:0, low_vac_r:0, low_voltage:1},
{ whiskey_compass: 3.981969, ai_pitch: 0.586431, ai_bank: -2.222677, ai_bars_position: 0.500000, caged: 0, ai_fail: 1, indicated_airspeed: 40.000000, airspeed_calibration_angle: 0.235618, airspeed_fail: 0, indicated_altitude: 2600.000000, kohlsman_setting: 28.875000, altitude_fail: 0, vertical_speed: 1025.000000, vertical_fail: 0, turn_coordinator_bank: -0.589049, turn_coordinator_ball: -103, plane_heading_magnetic: 3.981969, autopilot_heading_magnetic: 2.454369, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 3.981969, nav1_cdi: -103, nav1_gsi: -103, nav1_to_from: 2, nav1_gs_flag: 1, nav_fail: 0, nav2_available: 0, nav2_obs: 3.981969, nav2_cdi: -103, nav2_to_from: 2, adf1_radial: 3.981969, adf1_card: 3.981969, adf_fail: 0, engine_rpm: 2262, engine_elapsed_time: 10000.000000, engine_instruments_fail: 0, engine_oil_temp: 186.875000, engine_oil_pressure: 78.000000, engine_egt: 1350.000000, engine_fuel_flow: 13.650000, fuel_qty_left_tank: 16.900000, fuel_qty_right_tank: 16.900000, fuel_indicator_fail: 0, vacuum: 5.500000, vacuum_fail: 0, amp: -45.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:0, low_vac_l:0, low_vac_r:0, low_voltage:1},
{ whiskey_compass: 4.135121, ai_pitch: 0.688532, ai_bank: -2.069524, ai_bars_position: 0.600000, caged: 0, ai_fail: 1, indicated_airspeed: 50.000000, airspeed_calibration_angle: 0.282742, airspeed_fail: 0, indicated_altitude: 2700.000000, kohlsman_setting: 28.910000, altitude_fail: 0, vertical_speed: 1230.000000, vertical_fail: 0, turn_coordinator_bank: -0.549779, turn_coordinator_ball: -97, plane_heading_magnetic: 4.135121, autopilot_heading_magnetic: 2.301217, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 4.135121, nav1_cdi: -97, nav1_gsi: -97, nav1_to_from: 2, nav1_gs_flag: 1, nav_fail: 0, nav2_available: 0, nav2_obs: 4.135121, nav2_cdi: -97, nav2_to_from: 2, adf1_radial: 4.135121, adf1_card: 4.135121, adf_fail: 0, engine_rpm: 2349, engine_elapsed_time: 10000.200000, engine_instruments_fail: 0, engine_oil_temp: 190.750000, engine_oil_pressure: 81.000000, engine_egt: 1380.000000, engine_fuel_flow: 14.175000, fuel_qty_left_tank: 17.550000, fuel_qty_right_tank: 17.550000, fuel_indicator_fail: 0, vacuum: 5.600000, vacuum_fail: 0, amp: -42.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:0, low_vac_l:0, low_vac_r:0, low_voltage:1},
{ whiskey_compass: 4.288274, ai_pitch: 0.790634, ai_bank: -1.916372, ai_bars_position: 0.700000, caged: 0, ai_fail: 1, indicated_airspeed: 60.000000, airspeed_calibration_angle: 0.329866, airspeed_fail: 0, indicated_altitude: 2800.000000, kohlsman_setting: 28.945000, altitude_fail: 0, vertical_speed: 1435.000000, vertical_fail: 0, turn_coordinator_bank: -0.510509, turn_coordinator_ball: -91, plane_heading_magnetic: 4.288274, autopilot_heading_magnetic: 2.148064, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 4.288274, nav1_cdi: -91, nav1_gsi: -91, nav1_to_from: 2, nav1_gs_flag: 1, nav_fail: 0, nav2_available: 0, nav2_obs: 4.288274, nav2_cdi: -91, nav2_to_from: 2, adf1_radial: 4.288274, adf1_card: 4.288274, adf_fail: 0, engine_rpm: 2436, engine_elapsed_time: 10000.400000, engine_instruments_fail: 0, engine_oil_temp: 194.625000, engine_oil_pressure: 84.000000, engine_egt: 1410.000000, engine_fuel_flow: 14.700000, fuel_qty_left_tank: 18.200000, fuel_qty_right_tank: 18.200000, fuel_indicator_fail: 0, vacuum: 5.700000, vacuum_fail: 0, amp: -39.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:0, low_vac_l:0, low_vac_r:0, low_voltage:1},
{ whiskey_compass: 4.441427, ai_pitch: 0.892736, ai_bank: -1.763219, ai_bars_position: 0.800000, caged: 0, ai_fail: 1, indicated_airspeed: 70.000000, airspeed_calibration_angle: 0.376989, airspeed_fail: 0, indicated_altitude: 2900.000000, kohlsman_setting: 28.980000, altitude_fail: 0, vertical_speed: 1640.000000, vertical_fail: 0, turn_coordinator_bank: -0.471239, turn_coordinator_ball: -85, plane_heading_magnetic: 4.441427, autopilot_heading_magnetic: 1.994911, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 4.441427, nav1_cdi: -85, nav1_gsi: -85, nav1_to_from: 2, nav1_gs_flag: 1, nav_fail: 0, nav2_available: 0, nav2_obs: 4.441427, nav2_cdi: -85, nav2_to_from: 2, adf1_radial: 4.441427, adf1_card: 4.441427, adf_fail: 0, engine_rpm: 2523, engine_elapsed_time: 10000.600000, engine_instruments_fail: 0, engine_oil_temp: 198.500000, engine_oil_pressure: 87.000000, engine_egt: 1440.000000, engine_fuel_flow: 15.225000, fuel_qty_left_tank: 18.850000, fuel_qty_right_tank: 18.850000, fuel_indicator_fail: 0, vacuum: 5.800000, vacuum_fail: 0, amp: -36.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:0, low_vac_l:0, low_vac_r:1, low_voltage:1},
{ whiskey_compass: 4.594579, ai_pitch: 0.994838, ai_bank: -1.610066, ai_bars_position: 0.900000, caged: 0, ai_fail: 1, indicated_airspeed: 80.000000, airspeed_calibration_angle: 0.424113, airspeed_fail: 0, indicated_altitude: 3000.000000, kohlsman_setting: 29.015000, altitude_fail: 0, vertical_speed: 1845.000000, vertical_fail: 0, turn_coordinator_bank: -0.431969, turn_coordinator_ball: -79, plane_heading_magnetic: 4.594579, autopilot_heading_magnetic: 1.841759, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 4.594579, nav1_cdi: -79, nav1_gsi: -79, nav1_to_from: 3, nav1_gs_flag: 2, nav_fail: 0, nav2_available: 0, nav2_obs: 4.594579, nav2_cdi: -79, nav2_to_from: 3, adf1_radial: 4.594579, adf1_card: 4.594579, adf_fail: 0, engine_rpm: 2610, engine_elapsed_time: 10000.800000, engine_instruments_fail: 0, engine_oil_temp: 202.375000, engine_oil_pressure: 90.000000, engine_egt: 1470.000000, engine_fuel_flow: 15.750000, fuel_qty_left_tank: 19.500000, fuel_qty_right_tank: 19.500000, fuel_indicator_fail: 0, vacuum: 5.900000, vacuum_fail: 0, amp: -33.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:0, low_vac_l:0, low_vac_r:1, low_voltage:1},
{ whiskey_compass: 4.747732, ai_pitch: -1.047198, ai_bank: -1.456914, ai_bars_position: 1.000000, caged: 0, ai_fail: 1, indicated_airspeed: 90.000000, airspeed_calibration_angle: 0.471237, airspeed_fail: 0, indicated_altitude: 3100.000000, kohlsman_setting: 29.050000, altitude_fail: 0, vertical_speed: 2050.000000, vertical_fail: 0, turn_coordinator_bank: -0.392699, turn_coordinator_ball: -73, plane_heading_magnetic: 4.747732, autopilot_heading_magnetic: 1.688606, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 4.747732, nav1_cdi: -73, nav1_gsi: -73, nav1_to_from: 0, nav1_gs_flag: 0, nav_fail: 0, nav2_available: 0, nav2_obs: 4.747732, nav2_cdi: -73, nav2_to_from: 0, adf1_radial: 4.747732, adf1_card: 4.747732, adf_fail: 0, engine_rpm: 2697, engine_elapsed_time: 9999.000000, engine_instruments_fail: 0, engine_oil_temp: 206.250000, engine_oil_pressure: 93.000000, engine_egt: 1500.000000, engine_fuel_flow: 16.275000, fuel_qty_left_tank: 20.150000, fuel_qty_right_tank: 20.150000, fuel_indicator_fail: 0, vacuum: 6.000000, vacuum_fail: 0, amp: -30.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:0, low_vac_l:0, low_vac_r:1, low_voltage:1},
{ whiskey_compass: 4.900885, ai_pitch: -0.945096, ai_bank: -1.303761, ai_bars_position: -1.000000, caged: 0, ai_fail: 1, indicated_airspeed: 100.000000, airspeed_calibration_angle: -0.471237, airspeed_fail: 0, indicated_altitude: 3200.000000, kohlsman_setting: 29.085000, altitude_fail: 0, vertical_speed: -2050.000000, vertical_fail: 0, turn_coordinator_bank: -0.353429, turn_coordinator_ball: -67, plane_heading_magnetic: 4.900885, autopilot_heading_magnetic: 1.535453, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 4.900885, nav1_cdi: -67, nav1_gsi: -67, nav1_to_from: 0, nav1_gs_flag: 0, nav_fail: 0, nav2_available: 0, nav2_obs: 4.900885, nav2_cdi: -67, nav2_to_from: 0, adf1_radial: 4.900885, adf1_card: 4.900885, adf_fail: 0, engine_rpm: 2784, engine_elapsed_time: 9999.200000, engine_instruments_fail: 0, engine_oil_temp: 210.125000, engine_oil_pressure: 96.000000, engine_egt: 1530.000000, engine_fuel_flow: 16.800000, fuel_qty_left_tank: 20.800000, fuel_qty_right_tank: 20.800000, fuel_indicator_fail: 0, vacuum: 6.100000, vacuum_fail: 0, amp: -27.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:0, low_vac_l:0, low_vac_r:1, low_voltage:1},
{ whiskey_compass: 5.054037, ai_pitch: -0.842994, ai_bank: -1.150608, ai_bars_position: -0.900000, caged: 0, ai_fail: 1, indicated_airspeed: 110.000000, airspeed_calibration_angle: -0.424113, airspeed_fail: 0, indicated_altitude: 3300.000000, kohlsman_setting: 29.120000, altitude_fail: 0, vertical_speed: -1845.000000, vertical_fail: 0, turn_coordinator_bank: -0.314159, turn_coordinator_ball: -61, plane_heading_magnetic: 5.054037, autopilot_heading_magnetic: 1.382301, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 5.054037, nav1_cdi: -61, nav1_gsi: -61, nav1_to_from: 0, nav1_gs_flag: 0, nav_fail: 0, nav2_available: 0, nav2_obs: 5.054037, nav2_cdi: -61, nav2_to_from: 0, adf1_radial: 5.054037, adf1_card: 5.054037, adf_fail: 0, engine_rpm: 2871, engine_elapsed_time: 9999.400000, engine_instruments_fail: 0, engine_oil_temp: 214.000000, engine_oil_pressure: 99.000000, engine_egt: 1560.000000, engine_fuel_flow: 17.325000, fuel_qty_left_tank: 21.450000, fuel_qty_right_tank: 21.450000, fuel_indicator_fail: 0, vacuum: 6.200000, vacuum_fail: 0, amp: -24.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:0, low_vac_l:0, low_vac_r:1, low_voltage:1},
{ whiskey_compass: 5.207190, ai_pitch: -0.740892, ai_bank: -0.997456, ai_bars_position: -0.800000, caged: 0, ai_fail: 0, indicated_airspeed: 120.000000, airspeed_calibration_angle: -0.376989, airspeed_fail: 0, indicated_altitude: 3400.000000, kohlsman_setting: 29.155000, altitude_fail: 0, vertical_speed: -1640.000000, vertical_fail: 0, turn_coordinator_bank: -0.274889, turn_coordinator_ball: -55, plane_heading_magnetic: 5.207190, autopilot_heading_magnetic: 1.229148, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 5.207190, nav1_cdi: -55, nav1_gsi: -55, nav1_to_from: 0, nav1_gs_flag: 0, nav_fail: 0, nav2_available: 0, nav2_obs: 5.207190, nav2_cdi: -55, nav2_to_from: 0, adf1_radial: 5.207190, adf1_card: 5.207190, adf_fail: 0, engine_rpm: 2958, engine_elapsed_time: 9999.600000, engine_instruments_fail: 0, engine_oil_temp: 217.875000, engine_oil_pressure: 102.000000, engine_egt: 1590.000000, engine_fuel_flow: 17.850000, fuel_qty_left_tank: 22.100000, fuel_qty_right_tank: 22.100000, fuel_indicator_fail: 0, vacuum: 6.300000, vacuum_fail: 0, amp: -21.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:0, low_vac_l:0, low_vac_r:1, low_voltage:1},
{ whiskey_compass: 5.360342, ai_pitch: -0.638791, ai_bank: -0.844303, ai_bars_position: -0.700000, caged: 0, ai_fail: 0, indicated_airspeed: 130.000000, airspeed_calibration_angle: -0.329866, airspeed_fail: 0, indicated_altitude: 3500.000000, kohlsman_setting: 29.190000, altitude_fail: 0, vertical_speed: -1435.000000, vertical_fail: 0, turn_coordinator_bank: -0.235619, turn_coordinator_ball: -49, plane_heading_magnetic: 5.360342, autopilot_heading_magnetic: 1.075995, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 5.360342, nav1_cdi: -49, nav1_gsi: -49, nav1_to_from: 0, nav1_gs_flag: 0, nav_fail: 0, nav2_available: 0, nav2_obs: 5.360342, nav2_cdi: -49, nav2_to_from: 0, adf1_radial: 5.360342, adf1_card: 5.360342, adf_fail: 0, engine_rpm: 3045, engine_elapsed_time: 9999.800000, engine_instruments_fail: 0, engine_oil_temp: 221.750000, engine_oil_pressure: 105.000000, engine_egt: 1620.000000, engine_fuel_flow: 18.375000, fuel_qty_left_tank: 22.750000, fuel_qty_right_tank: 22.750000, fuel_indicator_fail: 0, vacuum: 6.400000, vacuum_fail: 0, amp: -18.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:0, low_vac_l:0, low_vac_r:1, low_voltage:1},
{ whiskey_compass: 5.513495, ai_pitch: -0.536689, ai_bank: -0.691150, ai_bars_position: -0.600000, caged: 0, ai_fail: 0, indicated_airspeed: 140.000000, airspeed_calibration_angle: -0.282742, airspeed_fail: 0, indicated_altitude: 3600.000000, kohlsman_setting: 29.225000, altitude_fail: 0, vertical_speed: -1230.000000, vertical_fail: 0, turn_coordinator_bank: -0.196350, turn_coordinator_ball: -43, plane_heading_magnetic: 5.513495, autopilot_heading_magnetic: 0.922843, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 5.513495, nav1_cdi: -43, nav1_gsi: -43, nav1_to_from: 0, nav1_gs_flag: 0, nav_fail: 0, nav2_available: 0, nav2_obs: 5.513495, nav2_cdi: -43, nav2_to_from: 0, adf1_radial: 5.513495, adf1_card: 5.513495, adf_fail: 0, engine_rpm: 3132, engine_elapsed_time: 10000.000000, engine_instruments_fail: 0, engine_oil_temp: 225.625000, engine_oil_pressure: 108.000000, engine_egt: 1650.000000, engine_fuel_flow: 18.900000, fuel_qty_left_tank: 23.400000, fuel_qty_right_tank: 23.400000, fuel_indicator_fail: 0, vacuum: 6.500000, vacuum_fail: 0, amp: -15.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:0, low_vac_l:0, low_vac_r:1, low_voltage:1},
{ whiskey_compass: 5.666648, ai_pitch: -0.434587, ai_bank: -0.537998, ai_bars_position: -0.500000, caged: 0, ai_fail: 0, indicated_airspeed: 150.000000, airspeed_calibration_angle: -0.235618, airspeed_fail: 0, indicated_altitude: 3700.000000, kohlsman_setting: 29.260000, altitude_fail: 0, vertical_speed: -1025.000000, vertical_fail: 0, turn_coordinator_bank: -0.157080, turn_coordinator_ball: -37, plane_heading_magnetic: 5.666648, autopilot_heading_magnetic: 0.769690, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 5.666648, nav1_cdi: -37, nav1_gsi: -37, nav1_to_from: 0, nav1_gs_flag: 0, nav_fail: 0, nav2_available: 0, nav2_obs: 5.666648, nav2_cdi: -37, nav2_to_from: 0, adf1_radial: 5.666648, adf1_card: 5.666648, adf_fail: 0, engine_rpm: 3219, engine_elapsed_time: 10000.200000, engine_instruments_fail: 0, engine_oil_temp: 229.500000, engine_oil_pressure: 111.000000, engine_egt: 1680.000000, engine_fuel_flow: 19.425000, fuel_qty_left_tank: 24.050000, fuel_qty_right_tank: 24.050000, fuel_indicator_fail: 0, vacuum: 6.600000, vacuum_fail: 0, amp: -12.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:0, low_vac_l:0, low_vac_r:1, low_voltage:1},
{ whiskey_compass: 5.819800, ai_pitch: -0.332485, ai_bank: -0.384845, ai_bars_position: -0.400000, caged: 0, ai_fail: 0, indicated_airspeed: 160.000000, airspeed_calibration_angle: -0.188495, airspeed_fail: 0, indicated_altitude: 3800.000000, kohlsman_setting: 29.295000, altitude_fail: 0, vertical_speed: -820.000000, vertical_fail: 0, turn_coordinator_bank: -0.117810, turn_coordinator_ball: -31, plane_heading_magnetic: 5.819800, autopilot_heading_magnetic: 0.616538, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 5.819800, nav1_cdi: -31, nav1_gsi: -31, nav1_to_from: 0, nav1_gs_flag: 0, nav_fail: 0, nav2_available: 0, nav2_obs: 5.819800, nav2_cdi: -31, nav2_to_from: 0, adf1_radial: 5.819800, adf1_card: 5.819800, adf_fail: 0, engine_rpm: 3306, engine_elapsed_time: 10000.400000, engine_instruments_fail: 0, engine_oil_temp: 233.375000, engine_oil_pressure: 114.000000, engine_egt: 1710.000000, engine_fuel_flow: 19.950000, fuel_qty_left_tank: 24.700000, fuel_qty_right_tank: 24.700000, fuel_indicator_fail: 0, vacuum: 6.700000, vacuum_fail: 0, amp: -9.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:0, low_vac_l:0, low_vac_r:1, low_voltage:1},
{ whiskey_compass: 5.972953, ai_pitch: -0.230383, ai_bank: -0.231692, ai_bars_position: -0.300000, caged: 0, ai_fail: 0, indicated_airspeed: 170.000000, airspeed_calibration_angle: -0.141371, airspeed_fail: 0, indicated_altitude: 3900.000000, kohlsman_setting: 29.330000, altitude_fail: 0, vertical_speed: -615.000000, vertical_fail: 0, turn_coordinator_bank: -0.078540, turn_coordinator_ball: -25, plane_heading_magnetic: 5.972953, autopilot_heading_magnetic: 0.463385, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 5.972953, nav1_cdi: -25, nav1_gsi: -25, nav1_to_from: 0, nav1_gs_flag: 0, nav_fail: 0, nav2_available: 0, nav2_obs: 5.972953, nav2_cdi: -25, nav2_to_from: 0, adf1_radial: 5.972953, adf1_card: 5.972953, adf_fail: 0, engine_rpm: 3393, engine_elapsed_time: 10000.600000, engine_instruments_fail: 0, engine_oil_temp: 237.250000, engine_oil_pressure: 117.000000, engine_egt: 1740.000000, engine_fuel_flow: 20.475000, fuel_qty_left_tank: 25.350000, fuel_qty_right_tank: 25.350000, fuel_indicator_fail: 0, vacuum: 6.800000, vacuum_fail: 0, amp: -6.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:0, low_vac_l:0, low_vac_r:1, low_voltage:1},
{ whiskey_compass: 6.126106, ai_pitch: -0.128282, ai_bank: -0.078540, ai_bars_position: -0.200000, caged: 0, ai_fail: 0, indicated_airspeed: 180.000000, airspeed_calibration_angle: -0.094247, airspeed_fail: 0, indicated_altitude: 4000.000000, kohlsman_setting: 29.365000, altitude_fail: 0, vertical_speed: -410.000000, vertical_fail: 0, turn_coordinator_bank: -0.039270, turn_coordinator_ball: -19, plane_heading_magnetic: 6.126106, autopilot_heading_magnetic: 0.310232, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 6.126106, nav1_cdi: -19, nav1_gsi: -19, nav1_to_from: 0, nav1_gs_flag: 0, nav_fail: 0, nav2_available: 0, nav2_obs: 6.126106, nav2_cdi: -19, nav2_to_from: 0, adf1_radial: 6.126106, adf1_card: 6.126106, adf_fail: 0, engine_rpm: 3480, engine_elapsed_time: 10000.800000, engine_instruments_fail: 0, engine_oil_temp: 241.125000, engine_oil_pressure: 120.000000, engine_egt: 1770.000000, engine_fuel_flow: 21.000000, fuel_qty_left_tank: 26.000000, fuel_qty_right_tank: 26.000000, fuel_indicator_fail: 0, vacuum: 6.900000, vacuum_fail: 0, amp: -3.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:0, low_vac_l:0, low_vac_r:1, low_voltage:1},
{ whiskey_compass: 0.000000, ai_pitch: -0.026180, ai_bank: 0.074613, ai_bars_position: -0.100000, caged: 0, ai_fail: 0, indicated_airspeed: 190.000000, airspeed_calibration_angle: -0.047124, airspeed_fail: 0, indicated_altitude: 4100.000000, kohlsman_setting: 29.400000, altitude_fail: 0, vertical_speed: -205.000000, vertical_fail: 0, turn_coordinator_bank: 0.000000, turn_coordinator_ball: -13, plane_heading_magnetic: 0.000000, autopilot_heading_magnetic: 0.157080, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 0.000000, nav1_cdi: -13, nav1_gsi: -13, nav1_to_from: 1, nav1_gs_flag: 0, nav_fail: 0, nav2_available: 0, nav2_obs: 0.000000, nav2_cdi: -13, nav2_to_from: 1, adf1_radial: 0.000000, adf1_card: 0.000000, adf_fail: 0, engine_rpm: 0, engine_elapsed_time: 9999.000000, engine_instruments_fail: 0, engine_oil_temp: 245.000000, engine_oil_pressure: 0.000000, engine_egt: 1800.000000, engine_fuel_flow: 0.000000, fuel_qty_left_tank: 0.000000, fuel_qty_right_tank: 0.000000, fuel_indicator_fail: 0, vacuum: 7.000000, vacuum_fail: 0, amp: 0.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:0, low_vac_l:0, low_vac_r:1, low_voltage:1},
{ whiskey_compass: 0.153153, ai_pitch: 0.075922, ai_bank: 0.227765, ai_bars_position: -0.000000, caged: 0, ai_fail: 0, indicated_airspeed: 200.000000, airspeed_calibration_angle: -0.000000, airspeed_fail: 0, indicated_altitude: 4200.000000, kohlsman_setting: 29.435000, altitude_fail: 0, vertical_speed: 0.000000, vertical_fail: 0, turn_coordinator_bank: 0.039270, turn_coordinator_ball: -7, plane_heading_magnetic: 0.153153, autopilot_heading_magnetic: 6.283185, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 0.153153, nav1_cdi: -7, nav1_gsi: -7, nav1_to_from: 1, nav1_gs_flag: 0, nav_fail: 0, nav2_available: 0, nav2_obs: 0.153153, nav2_cdi: -7, nav2_to_from: 1, adf1_radial: 0.153153, adf1_card: 0.153153, adf_fail: 0, engine_rpm: 87, engine_elapsed_time: 9999.200000, engine_instruments_fail: 0, engine_oil_temp: 90.000000, engine_oil_pressure: 3.000000, engine_egt: 600.000000, engine_fuel_flow: 0.525000, fuel_qty_left_tank: 0.650000, fuel_qty_right_tank: 0.650000, fuel_indicator_fail: 0, vacuum: 3.000000, vacuum_fail: 0, amp: 3.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:0, low_vac_l:0, low_vac_r:1, low_voltage:1},
{ whiskey_compass: 0.306305, ai_pitch: 0.178024, ai_bank: 0.380918, ai_bars_position: 0.100000, caged: 0, ai_fail: 0, indicated_airspeed: 210.000000, airspeed_calibration_angle: 0.047124, airspeed_fail: 0, indicated_altitude: 4300.000000, kohlsman_setting: 29.470000, altitude_fail: 0, vertical_speed: 205.000000, vertical_fail: 0, turn_coordinator_bank: 0.078540, turn_coordinator_ball: -1, plane_heading_magnetic: 0.306305, autopilot_heading_magnetic: 6.130033, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 0.306305, nav1_cdi: -1, nav1_gsi: -1, nav1_to_from: 1, nav1_gs_flag: 0, nav_fail: 0, nav2_available: 0, nav2_obs: 0.306305, nav2_cdi: -1, nav2_to_from: 1, adf1_radial: 0.306305, adf1_card: 0.306305, adf_fail: 0, engine_rpm: 174, engine_elapsed_time: 9999.400000, engine_instruments_fail: 0, engine_oil_temp: 93.875000, engine_oil_pressure: 6.000000, engine_egt: 630.000000, engine_fuel_flow: 1.050000, fuel_qty_left_tank: 1.300000, fuel_qty_right_tank: 1.300000, fuel_indicator_fail: 0, vacuum: 3.100000, vacuum_fail: 0, amp: 6.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:0, low_vac_l:0, low_vac_r:1, low_voltage:1},
{ whiskey_compass: 0.459458, ai_pitch: 0.280125, ai_bank: 0.534071, ai_bars_position: 0.200000, caged: 0, ai_fail: 0, indicated_airspeed: 0.000000, airspeed_calibration_angle: 0.094247, airspeed_fail: 0, indicated_altitude: 4400.000000, kohlsman_setting: 29.505000, altitude_fail: 0, vertical_speed: 410.000000, vertical_fail: 0, turn_coordinator_bank: 0.117810, turn_coordinator_ball: 5, plane_heading_magnetic: 0.459458, autopilot_heading_magnetic: 5.976880, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 0.459458, nav1_cdi: 5, nav1_gsi: 5, nav1_to_from: 1, nav1_gs_flag: 0, nav_fail: 0, nav2_available: 0, nav2_obs: 0.459458, nav2_cdi: 5, nav2_to_from: 1, adf1_radial: 0.459458, adf1_card: 0.459458, adf_fail: 0, engine_rpm: 261, engine_elapsed_time: 9999.600000, engine_instruments_fail: 0, engine_oil_temp: 97.750000, engine_oil_pressure: 9.000000, engine_egt: 660.000000, engine_fuel_flow: 1.575000, fuel_qty_left_tank: 1.950000, fuel_qty_right_tank: 1.950000, fuel_indicator_fail: 0, vacuum: 3.200000, vacuum_fail: 0, amp: 9.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:0, low_vac_l:0, low_vac_r:1, low_voltage:1},
{ whiskey_compass: 0.612611, ai_pitch: 0.382227, ai_bank: 0.687223, ai_bars_position: 0.300000, caged: 0, ai_fail: 0, indicated_airspeed: 10.000000, airspeed_calibration_angle: 0.141371, airspeed_fail: 0, indicated_altitude: 4500.000000, kohlsman_setting: 29.540000, altitude_fail: 0, vertical_speed: 615.000000, vertical_fail: 0, turn_coordinator_bank: 0.157080, turn_coordinator_ball: 11, plane_heading_magnetic: 0.612611, autopilot_heading_magnetic: 5.823727, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 0.612611, nav1_cdi: 11, nav1_gsi: 11, nav1_to_from: 1, nav1_gs_flag: 0, nav_fail: 0, nav2_available: 0, nav2_obs: 0.612611, nav2_cdi: 11, nav2_to_from: 1, adf1_radial: 0.612611, adf1_card: 0.612611, adf_fail: 0, engine_rpm: 348, engine_elapsed_time: 9999.800000, engine_instruments_fail: 0, engine_oil_temp: 101.625000, engine_oil_pressure: 12.000000, engine_egt: 690.000000, engine_fuel_flow: 2.100000, fuel_qty_left_tank: 2.600000, fuel_qty_right_tank: 2.600000, fuel_indicator_fail: 0, vacuum: 3.300000, vacuum_fail: 0, amp: 12.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:0, low_vac_l:1, low_vac_r:1, low_voltage:1},
{ whiskey_compass: 0.765763, ai_pitch: 0.484329, ai_bank: 0.840376, ai_bars_position: 0.400000, caged: 0, ai_fail: 0, indicated_airspeed: 20.000000, airspeed_calibration_angle: 0.188495, airspeed_fail: 0, indicated_altitude: 4600.000000, kohlsman_setting: 29.575000, altitude_fail: 0, vertical_speed: 820.000000, vertical_fail: 0, turn_coordinator_bank: 0.196350, turn_coordinator_ball: 17, plane_heading_magnetic: 0.765763, autopilot_heading_magnetic: 5.670575, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 0.765763, nav1_cdi: 17, nav1_gsi: 17, nav1_to_from: 1, nav1_gs_flag: 1, nav_fail: 0, nav2_available: 0, nav2_obs: 0.765763, nav2_cdi: 17, nav2_to_from: 1, adf1_radial: 0.765763, adf1_card: 0.765763, adf_fail: 0, engine_rpm: 435, engine_elapsed_time: 10000.000000, engine_instruments_fail: 0, engine_oil_temp: 105.500000, engine_oil_pressure: 15.000000, engine_egt: 720.000000, engine_fuel_flow: 2.625000, fuel_qty_left_tank: 3.250000, fuel_qty_right_tank: 3.250000, fuel_indicator_fail: 0, vacuum: 3.400000, vacuum_fail: 0, amp: 15.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:0, low_vac_l:1, low_vac_r:1, low_voltage:1},
{ whiskey_compass: 0.918916, ai_pitch: 0.586431, ai_bank: 0.993529, ai_bars_position: 0.500000, caged: 0, ai_fail: 0, indicated_airspeed: 30.000000, airspeed_calibration_angle: 0.235618, airspeed_fail: 0, indicated_altitude: 4700.000000, kohlsman_setting: 29.610000, altitude_fail: 0, vertical_speed: 1025.000000, vertical_fail: 0, turn_coordinator_bank: 0.235619, turn_coordinator_ball: 23, plane_heading_magnetic: 0.918916, autopilot_heading_magnetic: 5.517422, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 0.918916, nav1_cdi: 23, nav1_gsi: 23, nav1_to_from: 1, nav1_gs_flag: 1, nav_fail: 0, nav2_available: 0, nav2_obs: 0.918916, nav2_cdi: 23, nav2_to_from: 1, adf1_radial: 0.918916, adf1_card: 0.918916, adf_fail: 0, engine_rpm: 522, engine_elapsed_time: 10000.200000, engine_instruments_fail: 0, engine_oil_temp: 109.375000, engine_oil_pressure: 18.000000, engine_egt: 750.000000, engine_fuel_flow: 3.150000, fuel_qty_left_tank: 3.900000, fuel_qty_right_tank: 3.900000, fuel_indicator_fail: 0, vacuum: 3.500000, vacuum_fail: 0, amp: 18.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:0, low_vac_l:1, low_vac_r:1, low_voltage:1},
{ whiskey_compass: 1.072068, ai_pitch: 0.688532, ai_bank: 1.146681, ai_bars_position: 0.600000, caged: 0, ai_fail: 0, indicated_airspeed: 40.000000, airspeed_calibration_angle: 0.282742, airspeed_fail: 0, indicated_altitude: 4800.000000, kohlsman_setting: 29.645000, altitude_fail: 0, vertical_speed: 1230.000000, vertical_fail: 0, turn_coordinator_bank: 0.274889, turn_coordinator_ball: 29, plane_heading_magnetic: 1.072068, autopilot_heading_magnetic: 5.364269, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 1.072068, nav1_cdi: 29, nav1_gsi: 29, nav1_to_from: 1, nav1_gs_flag: 1, nav_fail: 0, nav2_available: 0, nav2_obs: 1.072068, nav2_cdi: 29, nav2_to_from: 1, adf1_radial: 1.072068, adf1_card: 1.072068, adf_fail: 0, engine_rpm: 609, engine_elapsed_time: 10000.400000, engine_instruments_fail: 0, engine_oil_temp: 113.250000, engine_oil_pressure: 21.000000, engine_egt: 780.000000, engine_fuel_flow: 3.675000, fuel_qty_left_tank: 4.550000, fuel_qty_right_tank: 4.550000, fuel_indicator_fail: 0, vacuum: 3.600000, vacuum_fail: 0, amp: 21.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:0, low_vac_l:1, low_vac_r:1, low_voltage:1},
{ whiskey_compass: 1.225221, ai_pitch: 0.790634, ai_bank: 1.299834, ai_bars_position: 0.700000, caged: 0, ai_fail: 0, indicated_airspeed: 50.000000, airspeed_calibration_angle: 0.329866, airspeed_fail: 0, indicated_altitude: 4900.000000, kohlsman_setting: 29.680000, altitude_fail: 0, vertical_speed: 1435.000000, vertical_fail: 0, turn_coordinator_bank: 0.314159, turn_coordinator_ball: 35, plane_heading_magnetic: 1.225221, autopilot_heading_magnetic: 5.211117, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 1.225221, nav1_cdi: 35, nav1_gsi: 35, nav1_to_from: 1, nav1_gs_flag: 1, nav_fail: 0, nav2_available: 0, nav2_obs: 1.225221, nav2_cdi: 35, nav2_to_from: 1, adf1_radial: 1.225221, adf1_card: 1.225221, adf_fail: 0, engine_rpm: 696, engine_elapsed_time: 10000.600000, engine_instruments_fail: 0, engine_oil_temp: 117.125000, engine_oil_pressure: 24.000000, engine_egt: 810.000000, engine_fuel_flow: 4.200000, fuel_qty_left_tank: 5.200000, fuel_qty_right_tank: 5.200000, fuel_indicator_fail: 0, vacuum: 3.700000, vacuum_fail: 0, amp: 24.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:0, low_vac_l:1, low_vac_r:1, low_voltage:1},
{ whiskey_compass: 1.378374, ai_pitch: 0.892736, ai_bank: 1.452987, ai_bars_position: 0.800000, caged: 0, ai_fail: 0, indicated_airspeed: 60.000000, airspeed_calibration_angle: 0.376989, airspeed_fail: 0, indicated_altitude: 5000.000000, kohlsman_setting: 29.715000, altitude_fail: 0, vertical_speed: 1640.000000, vertical_fail: 0, turn_coordinator_bank: 0.353429, turn_coordinator_ball: 41, plane_heading_magnetic: 1.378374, autopilot_heading_magnetic: 5.057964, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 1.378374, nav1_cdi: 41, nav1_gsi: 41, nav1_to_from: 1, nav1_gs_flag: 1, nav_fail: 0, nav2_available: 0, nav2_obs: 1.378374, nav2_cdi: 41, nav2_to_from: 1, adf1_radial: 1.378374, adf1_card: 1.378374, adf_fail: 0, engine_rpm: 783, engine_elapsed_time: 10000.800000, engine_instruments_fail: 0, engine_oil_temp: 121.000000, engine_oil_pressure: 27.000000, engine_egt: 840.000000, engine_fuel_flow: 4.725000, fuel_qty_left_tank: 5.850000, fuel_qty_right_tank: 5.850000, fuel_indicator_fail: 0, vacuum: 3.800000, vacuum_fail: 0, amp: 27.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:0, low_vac_l:1, low_vac_r:1, low_voltage:1},
{ whiskey_compass: 1.531526, ai_pitch: 0.994838, ai_bank: 1.606139, ai_bars_position: 0.900000, caged: 0, ai_fail: 0, indicated_airspeed: 70.000000, airspeed_calibration_angle: 0.424113, airspeed_fail: 0, indicated_altitude: 5100.000000, kohlsman_setting: 29.750000, altitude_fail: 0, vertical_speed: 1845.000000, vertical_fail: 0, turn_coordinator_bank: 0.392699, turn_coordinator_ball: 47, plane_heading_magnetic: 1.531526, autopilot_heading_magnetic: 4.904812, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 1.531526, nav1_cdi: 47, nav1_gsi: 47, nav1_to_from: 2, nav1_gs_flag: 1, nav_fail: 0, nav2_available: 0, nav2_obs: 1.531526, nav2_cdi: 47, nav2_to_from: 2, adf1_radial: 1.531526, adf1_card: 1.531526, adf_fail: 0, engine_rpm: 870, engine_elapsed_time: 9999.000000, engine_instruments_fail: 0, engine_oil_temp: 124.875000, engine_oil_pressure: 30.000000, engine_egt: 870.000000, engine_fuel_flow: 5.250000, fuel_qty_left_tank: 6.500000, fuel_qty_right_tank: 6.500000, fuel_indicator_fail: 0, vacuum: 3.900000, vacuum_fail: 0, amp: 30.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:0, low_vac_l:1, low_vac_r:1, low_voltage:1},
{ whiskey_compass: 1.684679, ai_pitch: -1.047198, ai_bank: 1.759292, ai_bars_position: 1.000000, caged: 0, ai_fail: 0, indicated_airspeed: 80.000000, airspeed_calibration_angle: 0.471237, airspeed_fail: 0, indicated_altitude: 5200.000000, kohlsman_setting: 29.785000, altitude_fail: 0, vertical_speed: 2050.000000, vertical_fail: 0, turn_coordinator_bank: 0.431969, turn_coordinator_ball: 53, plane_heading_magnetic: 1.684679, autopilot_heading_magnetic: 4.751659, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 1.684679, nav1_cdi: 53, nav1_gsi: 53, nav1_to_from: 2, nav1_gs_flag: 1, nav_fail: 0, nav2_available: 0, nav2_obs: 1.684679, nav2_cdi: 53, nav2_to_from: 2, adf1_radial: 1.684679, adf1_card: 1.684679, adf_fail: 0, engine_rpm: 957, engine_elapsed_time: 9999.200000, engine_instruments_fail: 0, engine_oil_temp: 128.750000, engine_oil_pressure: 33.000000, engine_egt: 900.000000, engine_fuel_flow: 5.775000, fuel_qty_left_tank: 7.150000, fuel_qty_right_tank: 7.150000, fuel_indicator_fail: 0, vacuum: 4.000000, vacuum_fail: 0, amp: 33.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:0, low_vac_l:1, low_vac_r:1, low_voltage:1},
{ whiskey_compass: 1.837832, ai_pitch: -0.945096, ai_bank: 1.912445, ai_bars_position: -1.000000, caged: 0, ai_fail: 0, indicated_airspeed: 90.000000, airspeed_calibration_angle: -0.471237, airspeed_fail: 0, indicated_altitude: 5300.000000, kohlsman_setting: 29.820000, altitude_fail: 0, vertical_speed: -2050.000000, vertical_fail: 0, turn_coordinator_bank: 0.471239, turn_coordinator_ball: 59, plane_heading_magnetic: 1.837832, autopilot_heading_magnetic: 4.598506, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 1.837832, nav1_cdi: 59, nav1_gsi: 59, nav1_to_from: 2, nav1_gs_flag: 1, nav_fail: 0, nav2_available: 0, nav2_obs: 1.837832, nav2_cdi: 59, nav2_to_from: 2, adf1_radial: 1.837832, adf1_card: 1.837832, adf_fail: 0, engine_rpm: 1044, engine_elapsed_time: 9999.400000, engine_instruments_fail: 0, engine_oil_temp: 132.625000, engine_oil_pressure: 36.000000, engine_egt: 930.000000, engine_fuel_flow: 6.300000, fuel_qty_left_tank: 7.800000, fuel_qty_right_tank: 7.800000, fuel_indicator_fail: 0, vacuum: 4.100000, vacuum_fail: 0, amp: 36.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:1, low_vac_l:1, low_vac_r:1, low_voltage:1},
{ whiskey_compass: 1.990984, ai_pitch: -0.842994, ai_bank: 2.065597, ai_bars_position: -0.900000, caged: 0, ai_fail: 0, indicated_airspeed: 100.000000, airspeed_calibration_angle: -0.424113, airspeed_fail: 0, indicated_altitude: 5400.000000, kohlsman_setting: 29.855000, altitude_fail: 0, vertical_speed: -1845.000000, vertical_fail: 0, turn_coordinator_bank: 0.510509, turn_coordinator_ball: 65, plane_heading_magnetic: 1.990984, autopilot_heading_magnetic: 4.445354, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 1.990984, nav1_cdi: 65, nav1_gsi: 65, nav1_to_from: 2, nav1_gs_flag: 1, nav_fail: 0, nav2_available: 0, nav2_obs: 1.990984, nav2_cdi: 65, nav2_to_from: 2, adf1_radial: 1.990984, adf1_card: 1.990984, adf_fail: 0, engine_rpm: 1131, engine_elapsed_time: 9999.600000, engine_instruments_fail: 0, engine_oil_temp: 136.500000, engine_oil_pressure: 39.000000, engine_egt: 960.000000, engine_fuel_flow: 6.825000, fuel_qty_left_tank: 8.450000, fuel_qty_right_tank: 8.450000, fuel_indicator_fail: 0, vacuum: 4.200000, vacuum_fail: 0, amp: 39.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:1, low_vac_l:1, low_vac_r:1, low_voltage:1},
{ whiskey_compass: 2.144137, ai_pitch: -0.740892, ai_bank: 2.218750, ai_bars_position: -0.800000, caged: 0, ai_fail: 0, indicated_airspeed: 110.000000, airspeed_calibration_angle: -0.376989, airspeed_fail: 0, indicated_altitude: 5500.000000, kohlsman_setting: 29.890000, altitude_fail: 0, vertical_speed: -1640.000000, vertical_fail: 0, turn_coordinator_bank: 0.549779, turn_coordinator_ball: 71, plane_heading_magnetic: 2.144137, autopilot_heading_magnetic: 4.292201, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 2.144137, nav1_cdi: 71, nav1_gsi: 71, nav1_to_from: 2, nav1_gs_flag: 1, nav_fail: 0, nav2_available: 0, nav2_obs: 2.144137, nav2_cdi: 71, nav2_to_from: 2, adf1_radial: 2.144137, adf1_card: 2.144137, adf_fail: 0, engine_rpm: 1218, engine_elapsed_time: 9999.800000, engine_instruments_fail: 0, engine_oil_temp: 140.375000, engine_oil_pressure: 42.000000, engine_egt: 990.000000, engine_fuel_flow: 7.350000, fuel_qty_left_tank: 9.100000, fuel_qty_right_tank: 9.100000, fuel_indicator_fail: 0, vacuum: 4.300000, vacuum_fail: 0, amp: 42.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:1, low_vac_l:1, low_vac_r:1, low_voltage:1},
{ whiskey_compass: 2.297290, ai_pitch: -0.638791, ai_bank: 2.371902, ai_bars_position: -0.700000, caged: 0, ai_fail: 0, indicated_airspeed: 120.000000, airspeed_calibration_angle: -0.329866, airspeed_fail: 0, indicated_altitude: 5600.000000, kohlsman_setting: 29.925000, altitude_fail: 0, vertical_speed: -1435.000000, vertical_fail: 0, turn_coordinator_bank: 0.589049, turn_coordinator_ball: 77, plane_heading_magnetic: 2.297290, autopilot_heading_magnetic: 4.139048, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 2.297290, nav1_cdi: 77, nav1_gsi: 77, nav1_to_from: 2, nav1_gs_flag: 1, nav_fail: 0, nav2_available: 0, nav2_obs: 2.297290, nav2_cdi: 77, nav2_to_from: 2, adf1_radial: 2.297290, adf1_card: 2.297290, adf_fail: 0, engine_rpm: 1305, engine_elapsed_time: 10000.000000, engine_instruments_fail: 0, engine_oil_temp: 144.250000, engine_oil_pressure: 45.000000, engine_egt: 1020.000000, engine_fuel_flow: 7.875000, fuel_qty_left_tank: 9.750000, fuel_qty_right_tank: 9.750000, fuel_indicator_fail: 0, vacuum: 4.400000, vacuum_fail: 0, amp: 45.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:1, low_vac_l:1, low_vac_r:1, low_voltage:1},
{ whiskey_compass: 2.450442, ai_pitch: -0.536689, ai_bank: 2.525055, ai_bars_position: -0.600000, caged: 0, ai_fail: 0, indicated_airspeed: 130.000000, airspeed_calibration_angle: -0.282742, airspeed_fail: 0, indicated_altitude: 5700.000000, kohlsman_setting: 29.960000, altitude_fail: 0, vertical_speed: -1230.000000, vertical_fail: 0, turn_coordinator_bank: 0.628319, turn_coordinator_ball: 83, plane_heading_magnetic: 2.450442, autopilot_heading_magnetic: 3.985896, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 2.450442, nav1_cdi: 83, nav1_gsi: 83, nav1_to_from: 2, nav1_gs_flag: 1, nav_fail: 0, nav2_available: 0, nav2_obs: 2.450442, nav2_cdi: 83, nav2_to_from: 2, adf1_radial: 2.450442, adf1_card: 2.450442, adf_fail: 0, engine_rpm: 1392, engine_elapsed_time: 10000.200000, engine_instruments_fail: 0, engine_oil_temp: 148.125000, engine_oil_pressure: 48.000000, engine_egt: 1050.000000, engine_fuel_flow: 8.400000, fuel_qty_left_tank: 10.400000, fuel_qty_right_tank: 10.400000, fuel_indicator_fail: 0, vacuum: 4.500000, vacuum_fail: 0, amp: 48.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:1, low_vac_l:1, low_vac_r:1, low_voltage:1},
{ whiskey_compass: 2.603595, ai_pitch: -0.434587, ai_bank: 2.678208, ai_bars_position: -0.500000, caged: 0, ai_fail: 0, indicated_airspeed: 140.000000, airspeed_calibration_angle: -0.235618, airspeed_fail: 0, indicated_altitude: 5800.000000, kohlsman_setting: 29.995000, altitude_fail: 0, vertical_speed: -1025.000000, vertical_fail: 0, turn_coordinator_bank: 0.667588, turn_coordinator_ball: 89, plane_heading_magnetic: 2.603595, autopilot_heading_magnetic: 3.832743, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 2.603595, nav1_cdi: 89, nav1_gsi: 89, nav1_to_from: 2, nav1_gs_flag: 1, nav_fail: 0, nav2_available: 0, nav2_obs: 2.603595, nav2_cdi: 89, nav2_to_from: 2, adf1_radial: 2.603595, adf1_card: 2.603595, adf_fail: 0, engine_rpm: 1479, engine_elapsed_time: 10000.400000, engine_instruments_fail: 0, engine_oil_temp: 152.000000, engine_oil_pressure: 51.000000, engine_egt: 1080.000000, engine_fuel_flow: 8.925000, fuel_qty_left_tank: 11.050000, fuel_qty_right_tank: 11.050000, fuel_indicator_fail: 0, vacuum: 4.600000, vacuum_fail: 0, amp: 51.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:1, low_vac_l:1, low_vac_r:1, low_voltage:1},
{ whiskey_compass: 2.756748, ai_pitch: -0.332485, ai_bank: 2.831360, ai_bars_position: -0.400000, caged: 0, ai_fail: 0, indicated_airspeed: 150.000000, airspeed_calibration_angle: -0.188495, airspeed_fail: 0, indicated_altitude: 5900.000000, kohlsman_setting: 30.030000, altitude_fail: 0, vertical_speed: -820.000000, vertical_fail: 0, turn_coordinator_bank: 0.706858, turn_coordinator_ball: 95, plane_heading_magnetic: 2.756748, autopilot_heading_magnetic: 3.679590, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 2.756748, nav1_cdi: 95, nav1_gsi: 95, nav1_to_from: 2, nav1_gs_flag: 1, nav_fail: 0, nav2_available: 0, nav2_obs: 2.756748, nav2_cdi: 95, nav2_to_from: 2, adf1_radial: 2.756748, adf1_card: 2.756748, adf_fail: 0, engine_rpm: 1566, engine_elapsed_time: 10000.600000, engine_instruments_fail: 0, engine_oil_temp: 155.875000, engine_oil_pressure: 54.000000, engine_egt: 1110.000000, engine_fuel_flow: 9.450000, fuel_qty_left_tank: 11.700000, fuel_qty_right_tank: 11.700000, fuel_indicator_fail: 0, vacuum: 4.700000, vacuum_fail: 0, amp: 54.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:1, low_vac_l:1, low_vac_r:1, low_voltage:1},
{ whiskey_compass: 2.909900, ai_pitch: -0.230383, ai_bank: 2.984513, ai_bars_position: -0.300000, caged: 0, ai_fail: 0, indicated_airspeed: 160.000000, airspeed_calibration_angle: -0.141371, airspeed_fail: 0, indicated_altitude: 6000.000000, kohlsman_setting: 30.065000, altitude_fail: 0, vertical_speed: -615.000000, vertical_fail: 0, turn_coordinator_bank: 0.746128, turn_coordinator_ball: 101, plane_heading_magnetic: 2.909900, autopilot_heading_magnetic: 3.526438, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 2.909900, nav1_cdi: 101, nav1_gsi: 101, nav1_to_from: 2, nav1_gs_flag: 1, nav_fail: 0, nav2_available: 0, nav2_obs: 2.909900, nav2_cdi: 101, nav2_to_from: 2, adf1_radial: 2.909900, adf1_card: 2.909900, adf_fail: 0, engine_rpm: 1653, engine_elapsed_time: 10000.800000, engine_instruments_fail: 0, engine_oil_temp: 159.750000, engine_oil_pressure: 57.000000, engine_egt: 1140.000000, engine_fuel_flow: 9.975000, fuel_qty_left_tank: 12.350000, fuel_qty_right_tank: 12.350000, fuel_indicator_fail: 0, vacuum: 4.800000, vacuum_fail: 0, amp: 57.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:1, low_vac_l:1, low_vac_r:1, low_voltage:1},
{ whiskey_compass: 3.063053, ai_pitch: -0.128282, ai_bank: -3.141593, ai_bars_position: -0.200000, caged: 0, ai_fail: 0, indicated_airspeed: 170.000000, airspeed_calibration_angle: -0.094247, airspeed_fail: 0, indicated_altitude: 6100.000000, kohlsman_setting: 30.100000, altitude_fail: 0, vertical_speed: -410.000000, vertical_fail: 0, turn_coordinator_bank: 0.785398, turn_coordinator_ball: 107, plane_heading_magnetic: 3.063053, autopilot_heading_magnetic: 3.373285, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 3.063053, nav1_cdi: 107, nav1_gsi: 107, nav1_to_from: 3, nav1_gs_flag: 2, nav_fail: 0, nav2_available: 0, nav2_obs: 3.063053, nav2_cdi: 107, nav2_to_from: 3, adf1_radial: 3.063053, adf1_card: 3.063053, adf_fail: 0, engine_rpm: 1740, engine_elapsed_time: 9999.000000, engine_instruments_fail: 0, engine_oil_temp: 163.625000, engine_oil_pressure: 60.000000, engine_egt: 1170.000000, engine_fuel_flow: 10.500000, fuel_qty_left_tank: 13.000000, fuel_qty_right_tank: 13.000000, fuel_indicator_fail: 0, vacuum: 4.900000, vacuum_fail: 0, amp: 60.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:1, low_vac_l:1, low_vac_r:1, low_voltage:1},
{ whiskey_compass: 3.216205, ai_pitch: -0.026180, ai_bank: -2.988440, ai_bars_position: -0.100000, caged: 0, ai_fail: 0, indicated_airspeed: 180.000000, airspeed_calibration_angle: -0.047124, airspeed_fail: 0, indicated_altitude: 6200.000000, kohlsman_setting: 30.135000, altitude_fail: 0, vertical_speed: -205.000000, vertical_fail: 0, turn_coordinator_bank: -0.785398, turn_coordinator_ball: 113, plane_heading_magnetic: 3.216205, autopilot_heading_magnetic: 3.220132, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 3.216205, nav1_cdi: 113, nav1_gsi: 113, nav1_to_from: 0, nav1_gs_flag: 0, nav_fail: 0, nav2_available: 0, nav2_obs: 3.216205, nav2_cdi: 113, nav2_to_from: 0, adf1_radial: 3.216205, adf1_card: 3.216205, adf_fail: 0, engine_rpm: 1827, engine_elapsed_time: 9999.200000, engine_instruments_fail: 0, engine_oil_temp: 167.500000, engine_oil_pressure: 63.000000, engine_egt: 1200.000000, engine_fuel_flow: 11.025000, fuel_qty_left_tank: 13.650000, fuel_qty_right_tank: 13.650000, fuel_indicator_fail: 0, vacuum: 5.000000, vacuum_fail: 0, amp: -60.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:1, low_vac_l:1, low_vac_r:1, low_voltage:1},
{ whiskey_compass: 3.369358, ai_pitch: 0.075922, ai_bank: -2.835287, ai_bars_position: -0.000000, caged: 0, ai_fail: 0, indicated_airspeed: 190.000000, airspeed_calibration_angle: -0.000000, airspeed_fail: 0, indicated_altitude: 6300.000000, kohlsman_setting: 30.170000, altitude_fail: 0, vertical_speed: 0.000000, vertical_fail: 0, turn_coordinator_bank: -0.746128, turn_coordinator_ball: 119, plane_heading_magnetic: 3.369358, autopilot_heading_magnetic: 3.066980, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 3.369358, nav1_cdi: 119, nav1_gsi: 119, nav1_to_from: 0, nav1_gs_flag: 0, nav_fail: 0, nav2_available: 0, nav2_obs: 3.369358, nav2_cdi: 119, nav2_to_from: 0, adf1_radial: 3.369358, adf1_card: 3.369358, adf_fail: 0, engine_rpm: 1914, engine_elapsed_time: 9999.400000, engine_instruments_fail: 0, engine_oil_temp: 171.375000, engine_oil_pressure: 66.000000, engine_egt: 1230.000000, engine_fuel_flow: 11.550000, fuel_qty_left_tank: 14.300000, fuel_qty_right_tank: 14.300000, fuel_indicator_fail: 0, vacuum: 5.100000, vacuum_fail: 0, amp: -57.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:0, low_oil_pressure:1, low_vac_l:1, low_vac_r:1, low_voltage:1},
{ whiskey_compass: 3.522511, ai_pitch: 0.178024, ai_bank: -2.682135, ai_bars_position: 0.100000, caged: 0, ai_fail: 0, indicated_airspeed: 200.000000, airspeed_calibration_angle: 0.047124, airspeed_fail: 0, indicated_altitude: 6400.000000, kohlsman_setting: 30.205000, altitude_fail: 0, vertical_speed: 205.000000, vertical_fail: 0, turn_coordinator_bank: -0.706858, turn_coordinator_ball: 125, plane_heading_magnetic: 3.522511, autopilot_heading_magnetic: 2.913827, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 3.522511, nav1_cdi: 125, nav1_gsi: 125, nav1_to_from: 0, nav1_gs_flag: 0, nav_fail: 0, nav2_available: 0, nav2_obs: 3.522511, nav2_cdi: 125, nav2_to_from: 0, adf1_radial: 3.522511, adf1_card: 3.522511, adf_fail: 0, engine_rpm: 2001, engine_elapsed_time: 9999.600000, engine_instruments_fail: 0, engine_oil_temp: 175.250000, engine_oil_pressure: 69.000000, engine_egt: 1260.000000, engine_fuel_flow: 12.075000, fuel_qty_left_tank: 14.950000, fuel_qty_right_tank: 14.950000, fuel_indicator_fail: 0, vacuum: 5.200000, vacuum_fail: 0, amp: -54.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:1, low_oil_pressure:1, low_vac_l:1, low_vac_r:1, low_voltage:1},
{ whiskey_compass: 3.675663, ai_pitch: 0.280125, ai_bank: -2.528982, ai_bars_position: 0.200000, caged: 0, ai_fail: 0, indicated_airspeed: 210.000000, airspeed_calibration_angle: 0.094247, airspeed_fail: 0, indicated_altitude: 6500.000000, kohlsman_setting: 30.240000, altitude_fail: 0, vertical_speed: 410.000000, vertical_fail: 0, turn_coordinator_bank: -0.667588, turn_coordinator_ball: -127, plane_heading_magnetic: 3.675663, autopilot_heading_magnetic: 2.760675, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 3.675663, nav1_cdi: -127, nav1_gsi: -127, nav1_to_from: 0, nav1_gs_flag: 0, nav_fail: 0, nav2_available: 0, nav2_obs: 3.675663, nav2_cdi: -127, nav2_to_from: 0, adf1_radial: 3.675663, adf1_card: 3.675663, adf_fail: 0, engine_rpm: 2088, engine_elapsed_time: 9999.800000, engine_instruments_fail: 0, engine_oil_temp: 179.125000, engine_oil_pressure: 72.000000, engine_egt: 1290.000000, engine_fuel_flow: 12.600000, fuel_qty_left_tank: 15.600000, fuel_qty_right_tank: 15.600000, fuel_indicator_fail: 0, vacuum: 5.300000, vacuum_fail: 0, amp: -51.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:1, low_oil_pressure:1, low_vac_l:1, low_vac_r:1, low_voltage:1},
{ whiskey_compass: 3.828816, ai_pitch: 0.382227, ai_bank: -2.375829, ai_bars_position: 0.300000, caged: 0, ai_fail: 0, indicated_airspeed: 0.000000, airspeed_calibration_angle: 0.141371, airspeed_fail: 0, indicated_altitude: 6600.000000, kohlsman_setting: 30.275000, altitude_fail: 0, vertical_speed: 615.000000, vertical_fail: 0, turn_coordinator_bank: -0.628319, turn_coordinator_ball: -121, plane_heading_magnetic: 3.828816, autopilot_heading_magnetic: 2.607522, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 3.828816, nav1_cdi: -121, nav1_gsi: -121, nav1_to_from: 0, nav1_gs_flag: 0, nav_fail: 0, nav2_available: 0, nav2_obs: 3.828816, nav2_cdi: -121, nav2_to_from: 0, adf1_radial: 3.828816, adf1_card: 3.828816, adf_fail: 0, engine_rpm: 2175, engine_elapsed_time: 10000.000000, engine_instruments_fail: 0, engine_oil_temp: 183.000000, engine_oil_pressure: 75.000000, engine_egt: 1320.000000, engine_fuel_flow: 13.125000, fuel_qty_left_tank: 16.250000, fuel_qty_right_tank: 16.250000, fuel_indicator_fail: 0, vacuum: 5.400000, vacuum_fail: 0, amp: -48.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:1, low_oil_pressure:1, low_vac_l:1, low_vac_r:1, low_voltage:1},
{ whiskey_compass: 3.981969, ai_pitch: 0.484329, ai_bank: -2.222677, ai_bars_position: 0.400000, caged: 0, ai_fail: 0, indicated_airspeed: 10.000000, airspeed_calibration_angle: 0.188495, airspeed_fail: 0, indicated_altitude: 6700.000000, kohlsman_setting: 30.310000, altitude_fail: 0, vertical_speed: 820.000000, vertical_fail: 0, turn_coordinator_bank: -0.589049, turn_coordinator_ball: -115, plane_heading_magnetic: 3.981969, autopilot_heading_magnetic: 2.454369, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 3.981969, nav1_cdi: -115, nav1_gsi: -115, nav1_to_from: 0, nav1_gs_flag: 0, nav_fail: 0, nav2_available: 0, nav2_obs: 3.981969, nav2_cdi: -115, nav2_to_from: 0, adf1_radial: 3.981969, adf1_card: 3.981969, adf_fail: 0, engine_rpm: 2262, engine_elapsed_time: 10000.200000, engine_instruments_fail: 0, engine_oil_temp: 186.875000, engine_oil_pressure: 78.000000, engine_egt: 1350.000000, engine_fuel_flow: 13.650000, fuel_qty_left_tank: 16.900000, fuel_qty_right_tank: 16.900000, fuel_indicator_fail: 0, vacuum: 5.500000, vacuum_fail: 0, amp: -45.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:1, low_oil_pressure:1, low_vac_l:1, low_vac_r:1, low_voltage:1},
{ whiskey_compass: 4.135121, ai_pitch: 0.586431, ai_bank: -2.069524, ai_bars_position: 0.500000, caged: 0, ai_fail: 0, indicated_airspeed: 20.000000, airspeed_calibration_angle: 0.235618, airspeed_fail: 0, indicated_altitude: 6800.000000, kohlsman_setting: 30.345000, altitude_fail: 0, vertical_speed: 1025.000000, vertical_fail: 0, turn_coordinator_bank: -0.549779, turn_coordinator_ball: -109, plane_heading_magnetic: 4.135121, autopilot_heading_magnetic: 2.301217, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 4.135121, nav1_cdi: -109, nav1_gsi: -109, nav1_to_from: 0, nav1_gs_flag: 0, nav_fail: 0, nav2_available: 0, nav2_obs: 4.135121, nav2_cdi: -109, nav2_to_from: 0, adf1_radial: 4.135121, adf1_card: 4.135121, adf_fail: 0, engine_rpm: 2349, engine_elapsed_time: 10000.400000, engine_instruments_fail: 0, engine_oil_temp: 190.750000, engine_oil_pressure: 81.000000, engine_egt: 1380.000000, engine_fuel_flow: 14.175000, fuel_qty_left_tank: 17.550000, fuel_qty_right_tank: 17.550000, fuel_indicator_fail: 0, vacuum: 5.600000, vacuum_fail: 0, amp: -42.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:1, low_oil_pressure:1, low_vac_l:1, low_vac_r:1, low_voltage:1},
{ whiskey_compass: 4.288274, ai_pitch: 0.688532, ai_bank: -1.916372, ai_bars_position: 0.600000, caged: 0, ai_fail: 0, indicated_airspeed: 30.000000, airspeed_calibration_angle: 0.282742, airspeed_fail: 0, indicated_altitude: 6900.000000, kohlsman_setting: 30.380000, altitude_fail: 0, vertical_speed: 1230.000000, vertical_fail: 0, turn_coordinator_bank: -0.510509, turn_coordinator_ball: -103, plane_heading_magnetic: 4.288274, autopilot_heading_magnetic: 2.148064, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 4.288274, nav1_cdi: -103, nav1_gsi: -103, nav1_to_from: 0, nav1_gs_flag: 0, nav_fail: 0, nav2_available: 0, nav2_obs: 4.288274, nav2_cdi: -103, nav2_to_from: 0, adf1_radial: 4.288274, adf1_card: 4.288274, adf_fail: 0, engine_rpm: 2436, engine_elapsed_time: 10000.600000, engine_instruments_fail: 0, engine_oil_temp: 194.625000, engine_oil_pressure: 84.000000, engine_egt: 1410.000000, engine_fuel_flow: 14.700000, fuel_qty_left_tank: 18.200000, fuel_qty_right_tank: 18.200000, fuel_indicator_fail: 0, vacuum: 5.700000, vacuum_fail: 0, amp: -39.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:1, low_oil_pressure:1, low_vac_l:1, low_vac_r:1, low_voltage:1},
{ whiskey_compass: 4.441427, ai_pitch: 0.790634, ai_bank: -1.763219, ai_bars_position: 0.700000, caged: 0, ai_fail: 0, indicated_airspeed: 40.000000, airspeed_calibration_angle: 0.329866, airspeed_fail: 0, indicated_altitude: 7000.000000, kohlsman_setting: 30.415000, altitude_fail: 0, vertical_speed: 1435.000000, vertical_fail: 0, turn_coordinator_bank: -0.471239, turn_coordinator_ball: -97, plane_heading_magnetic: 4.441427, autopilot_heading_magnetic: 1.994911, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 4.441427, nav1_cdi: -97, nav1_gsi: -97, nav1_to_from: 0, nav1_gs_flag: 0, nav_fail: 0, nav2_available: 0, nav2_obs: 4.441427, nav2_cdi: -97, nav2_to_from: 0, adf1_radial: 4.441427, adf1_card: 4.441427, adf_fail: 0, engine_rpm: 2523, engine_elapsed_time: 10000.800000, engine_instruments_fail: 0, engine_oil_temp: 198.500000, engine_oil_pressure: 87.000000, engine_egt: 1440.000000, engine_fuel_flow: 15.225000, fuel_qty_left_tank: 18.850000, fuel_qty_right_tank: 18.850000, fuel_indicator_fail: 0, vacuum: 5.800000, vacuum_fail: 0, amp: -36.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:1, low_oil_pressure:1, low_vac_l:1, low_vac_r:1, low_voltage:1},
{ whiskey_compass: 4.594579, ai_pitch: 0.892736, ai_bank: -1.610066, ai_bars_position: 0.800000, caged: 0, ai_fail: 0, indicated_airspeed: 50.000000, airspeed_calibration_angle: 0.376989, airspeed_fail: 0, indicated_altitude: 7100.000000, kohlsman_setting: 30.450000, altitude_fail: 0, vertical_speed: 1640.000000, vertical_fail: 0, turn_coordinator_bank: -0.431969, turn_coordinator_ball: -91, plane_heading_magnetic: 4.594579, autopilot_heading_magnetic: 1.841759, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 4.594579, nav1_cdi: -91, nav1_gsi: -91, nav1_to_from: 0, nav1_gs_flag: 0, nav_fail: 0, nav2_available: 0, nav2_obs: 4.594579, nav2_cdi: -91, nav2_to_from: 0, adf1_radial: 4.594579, adf1_card: 4.594579, adf_fail: 0, engine_rpm: 2610, engine_elapsed_time: 9999.000000, engine_instruments_fail: 0, engine_oil_temp: 202.375000, engine_oil_pressure: 90.000000, engine_egt: 1470.000000, engine_fuel_flow: 15.750000, fuel_qty_left_tank: 19.500000, fuel_qty_right_tank: 19.500000, fuel_indicator_fail: 0, vacuum: 5.900000, vacuum_fail: 0, amp: -33.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:1, low_oil_pressure:1, low_vac_l:1, low_vac_r:1, low_voltage:1},
{ whiskey_compass: 4.747732, ai_pitch: 0.994838, ai_bank: -1.456914, ai_bars_position: 0.900000, caged: 0, ai_fail: 0, indicated_airspeed: 60.000000, airspeed_calibration_angle: 0.424113, airspeed_fail: 0, indicated_altitude: 7200.000000, kohlsman_setting: 30.485000, altitude_fail: 0, vertical_speed: 1845.000000, vertical_fail: 0, turn_coordinator_bank: -0.392699, turn_coordinator_ball: -85, plane_heading_magnetic: 4.747732, autopilot_heading_magnetic: 1.688606, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 4.747732, nav1_cdi: -85, nav1_gsi: -85, nav1_to_from: 1, nav1_gs_flag: 0, nav_fail: 0, nav2_available: 0, nav2_obs: 4.747732, nav2_cdi: -85, nav2_to_from: 1, adf1_radial: 4.747732, adf1_card: 4.747732, adf_fail: 0, engine_rpm: 2697, engine_elapsed_time: 9999.200000, engine_instruments_fail: 0, engine_oil_temp: 206.250000, engine_oil_pressure: 93.000000, engine_egt: 1500.000000, engine_fuel_flow: 16.275000, fuel_qty_left_tank: 20.150000, fuel_qty_right_tank: 20.150000, fuel_indicator_fail: 0, vacuum: 6.000000, vacuum_fail: 0, amp: -30.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:0, low_fuel_r:1, low_oil_pressure:1, low_vac_l:1, low_vac_r:1, low_voltage:1},
{ whiskey_compass: 4.900885, ai_pitch: -1.047198, ai_bank: -1.303761, ai_bars_position: 1.000000, caged: 0, ai_fail: 0, indicated_airspeed: 70.000000, airspeed_calibration_angle: 0.471237, airspeed_fail: 0, indicated_altitude: 7300.000000, kohlsman_setting: 30.520000, altitude_fail: 0, vertical_speed: 2050.000000, vertical_fail: 0, turn_coordinator_bank: -0.353429, turn_coordinator_ball: -79, plane_heading_magnetic: 4.900885, autopilot_heading_magnetic: 1.535453, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 4.900885, nav1_cdi: -79, nav1_gsi: -79, nav1_to_from: 1, nav1_gs_flag: 0, nav_fail: 0, nav2_available: 0, nav2_obs: 4.900885, nav2_cdi: -79, nav2_to_from: 1, adf1_radial: 4.900885, adf1_card: 4.900885, adf_fail: 0, engine_rpm: 2784, engine_elapsed_time: 9999.400000, engine_instruments_fail: 0, engine_oil_temp: 210.125000, engine_oil_pressure: 96.000000, engine_egt: 1530.000000, engine_fuel_flow: 16.800000, fuel_qty_left_tank: 20.800000, fuel_qty_right_tank: 20.800000, fuel_indicator_fail: 0, vacuum: 6.100000, vacuum_fail: 0, amp: -27.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:1, low_fuel_r:1, low_oil_pressure:1, low_vac_l:1, low_vac_r:1, low_voltage:1},
{ whiskey_compass: 5.054037, ai_pitch: -0.945096, ai_bank: -1.150608, ai_bars_position: -1.000000, caged: 0, ai_fail: 0, indicated_airspeed: 80.000000, airspeed_calibration_angle: -0.471237, airspeed_fail: 0, indicated_altitude: 7400.000000, kohlsman_setting: 30.555000, altitude_fail: 0, vertical_speed: -2050.000000, vertical_fail: 0, turn_coordinator_bank: -0.314159, turn_coordinator_ball: -73, plane_heading_magnetic: 5.054037, autopilot_heading_magnetic: 1.382301, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 5.054037, nav1_cdi: -73, nav1_gsi: -73, nav1_to_from: 1, nav1_gs_flag: 0, nav_fail: 0, nav2_available: 0, nav2_obs: 5.054037, nav2_cdi: -73, nav2_to_from: 1, adf1_radial: 5.054037, adf1_card: 5.054037, adf_fail: 0, engine_rpm: 2871, engine_elapsed_time: 9999.600000, engine_instruments_fail: 0, engine_oil_temp: 214.000000, engine_oil_pressure: 99.000000, engine_egt: 1560.000000, engine_fuel_flow: 17.325000, fuel_qty_left_tank: 21.450000, fuel_qty_right_tank: 21.450000, fuel_indicator_fail: 0, vacuum: 6.200000, vacuum_fail: 0, amp: -24.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:1, low_fuel_r:1, low_oil_pressure:1, low_vac_l:1, low_vac_r:1, low_voltage:1},
{ whiskey_compass: 5.207190, ai_pitch: -0.842994, ai_bank: -0.997456, ai_bars_position: -0.900000, caged: 0, ai_fail: 0, indicated_airspeed: 90.000000, airspeed_calibration_angle: -0.424113, airspeed_fail: 0, indicated_altitude: 7500.000000, kohlsman_setting: 30.590000, altitude_fail: 0, vertical_speed: -1845.000000, vertical_fail: 0, turn_coordinator_bank: -0.274889, turn_coordinator_ball: -67, plane_heading_magnetic: 5.207190, autopilot_heading_magnetic: 1.229148, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 5.207190, nav1_cdi: -67, nav1_gsi: -67, nav1_to_from: 1, nav1_gs_flag: 0, nav_fail: 0, nav2_available: 0, nav2_obs: 5.207190, nav2_cdi: -67, nav2_to_from: 1, adf1_radial: 5.207190, adf1_card: 5.207190, adf_fail: 0, engine_rpm: 2958, engine_elapsed_time: 9999.800000, engine_instruments_fail: 0, engine_oil_temp: 217.875000, engine_oil_pressure: 102.000000, engine_egt: 1590.000000, engine_fuel_flow: 17.850000, fuel_qty_left_tank: 22.100000, fuel_qty_right_tank: 22.100000, fuel_indicator_fail: 0, vacuum: 6.300000, vacuum_fail: 0, amp: -21.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:1, low_fuel_r:1, low_oil_pressure:1, low_vac_l:1, low_vac_r:1, low_voltage:1},
{ whiskey_compass: 5.360342, ai_pitch: -0.740892, ai_bank: -0.844303, ai_bars_position: -0.800000, caged: 0, ai_fail: 0, indicated_airspeed: 100.000000, airspeed_calibration_angle: -0.376989, airspeed_fail: 0, indicated_altitude: 7600.000000, kohlsman_setting: 30.625000, altitude_fail: 0, vertical_speed: -1640.000000, vertical_fail: 0, turn_coordinator_bank: -0.235619, turn_coordinator_ball: -61, plane_heading_magnetic: 5.360342, autopilot_heading_magnetic: 1.075995, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 5.360342, nav1_cdi: -61, nav1_gsi: -61, nav1_to_from: 1, nav1_gs_flag: 0, nav_fail: 0, nav2_available: 0, nav2_obs: 5.360342, nav2_cdi: -61, nav2_to_from: 1, adf1_radial: 5.360342, adf1_card: 5.360342, adf_fail: 0, engine_rpm: 3045, engine_elapsed_time: 10000.000000, engine_instruments_fail: 0, engine_oil_temp: 221.750000, engine_oil_pressure: 105.000000, engine_egt: 1620.000000, engine_fuel_flow: 18.375000, fuel_qty_left_tank: 22.750000, fuel_qty_right_tank: 22.750000, fuel_indicator_fail: 0, vacuum: 6.400000, vacuum_fail: 0, amp: -18.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:1, low_fuel_r:1, low_oil_pressure:1, low_vac_l:1, low_vac_r:1, low_voltage:1},
{ whiskey_compass: 5.513495, ai_pitch: -0.638791, ai_bank: -0.691150, ai_bars_position: -0.700000, caged: 0, ai_fail: 0, indicated_airspeed: 110.000000, airspeed_calibration_angle: -0.329866, airspeed_fail: 0, indicated_altitude: 7700.000000, kohlsman_setting: 30.660000, altitude_fail: 0, vertical_speed: -1435.000000, vertical_fail: 0, turn_coordinator_bank: -0.196350, turn_coordinator_ball: -55, plane_heading_magnetic: 5.513495, autopilot_heading_magnetic: 0.922843, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 5.513495, nav1_cdi: -55, nav1_gsi: -55, nav1_to_from: 1, nav1_gs_flag: 1, nav_fail: 0, nav2_available: 0, nav2_obs: 5.513495, nav2_cdi: -55, nav2_to_from: 1, adf1_radial: 5.513495, adf1_card: 5.513495, adf_fail: 0, engine_rpm: 3132, engine_elapsed_time: 10000.200000, engine_instruments_fail: 0, engine_oil_temp: 225.625000, engine_oil_pressure: 108.000000, engine_egt: 1650.000000, engine_fuel_flow: 18.900000, fuel_qty_left_tank: 23.400000, fuel_qty_right_tank: 23.400000, fuel_indicator_fail: 0, vacuum: 6.500000, vacuum_fail: 0, amp: -15.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:1, low_fuel_r:1, low_oil_pressure:1, low_vac_l:1, low_vac_r:1, low_voltage:1},
{ whiskey_compass: 5.666648, ai_pitch: -0.536689, ai_bank: -0.537998, ai_bars_position: -0.600000, caged: 0, ai_fail: 0, indicated_airspeed: 120.000000, airspeed_calibration_angle: -0.282742, airspeed_fail: 0, indicated_altitude: 7800.000000, kohlsman_setting: 30.695000, altitude_fail: 0, vertical_speed: -1230.000000, vertical_fail: 0, turn_coordinator_bank: -0.157080, turn_coordinator_ball: -49, plane_heading_magnetic: 5.666648, autopilot_heading_magnetic: 0.769690, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 5.666648, nav1_cdi: -49, nav1_gsi: -49, nav1_to_from: 1, nav1_gs_flag: 1, nav_fail: 0, nav2_available: 0, nav2_obs: 5.666648, nav2_cdi: -49, nav2_to_from: 1, adf1_radial: 5.666648, adf1_card: 5.666648, adf_fail: 0, engine_rpm: 3219, engine_elapsed_time: 10000.400000, engine_instruments_fail: 0, engine_oil_temp: 229.500000, engine_oil_pressure: 111.000000, engine_egt: 1680.000000, engine_fuel_flow: 19.425000, fuel_qty_left_tank: 24.050000, fuel_qty_right_tank: 24.050000, fuel_indicator_fail: 0, vacuum: 6.600000, vacuum_fail: 0, amp: -12.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:1, low_fuel_r:1, low_oil_pressure:1, low_vac_l:1, low_vac_r:1, low_voltage:1},
{ whiskey_compass: 5.819800, ai_pitch: -0.434587, ai_bank: -0.384845, ai_bars_position: -0.500000, caged: 0, ai_fail: 0, indicated_airspeed: 130.000000, airspeed_calibration_angle: -0.235618, airspeed_fail: 0, indicated_altitude: 7900.000000, kohlsman_setting: 30.730000, altitude_fail: 0, vertical_speed: -1025.000000, vertical_fail: 0, turn_coordinator_bank: -0.117810, turn_coordinator_ball: -43, plane_heading_magnetic: 5.819800, autopilot_heading_magnetic: 0.616538, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 5.819800, nav1_cdi: -43, nav1_gsi: -43, nav1_to_from: 1, nav1_gs_flag: 1, nav_fail: 0, nav2_available: 0, nav2_obs: 5.819800, nav2_cdi: -43, nav2_to_from: 1, adf1_radial: 5.819800, adf1_card: 5.819800, adf_fail: 0, engine_rpm: 3306, engine_elapsed_time: 10000.600000, engine_instruments_fail: 0, engine_oil_temp: 233.375000, engine_oil_pressure: 114.000000, engine_egt: 1710.000000, engine_fuel_flow: 19.950000, fuel_qty_left_tank: 24.700000, fuel_qty_right_tank: 24.700000, fuel_indicator_fail: 0, vacuum: 6.700000, vacuum_fail: 0, amp: -9.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:1, low_fuel_r:1, low_oil_pressure:1, low_vac_l:1, low_vac_r:1, low_voltage:1},
{ whiskey_compass: 5.972953, ai_pitch: -0.332485, ai_bank: -0.231692, ai_bars_position: -0.400000, caged: 0, ai_fail: 0, indicated_airspeed: 140.000000, airspeed_calibration_angle: -0.188495, airspeed_fail: 0, indicated_altitude: 8000.000000, kohlsman_setting: 30.765000, altitude_fail: 0, vertical_speed: -820.000000, vertical_fail: 0, turn_coordinator_bank: -0.078540, turn_coordinator_ball: -37, plane_heading_magnetic: 5.972953, autopilot_heading_magnetic: 0.463385, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 5.972953, nav1_cdi: -37, nav1_gsi: -37, nav1_to_from: 1, nav1_gs_flag: 1, nav_fail: 0, nav2_available: 0, nav2_obs: 5.972953, nav2_cdi: -37, nav2_to_from: 1, adf1_radial: 5.972953, adf1_card: 5.972953, adf_fail: 0, engine_rpm: 3393, engine_elapsed_time: 10000.800000, engine_instruments_fail: 0, engine_oil_temp: 237.250000, engine_oil_pressure: 117.000000, engine_egt: 1740.000000, engine_fuel_flow: 20.475000, fuel_qty_left_tank: 25.350000, fuel_qty_right_tank: 25.350000, fuel_indicator_fail: 0, vacuum: 6.800000, vacuum_fail: 0, amp: -6.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:1, low_fuel_r:1, low_oil_pressure:1, low_vac_l:1, low_vac_r:1, low_voltage:1},
{ whiskey_compass: 6.126106, ai_pitch: -0.230383, ai_bank: -0.078540, ai_bars_position: -0.300000, caged: 0, ai_fail: 0, indicated_airspeed: 150.000000, airspeed_calibration_angle: -0.141371, airspeed_fail: 0, indicated_altitude: 8100.000000, kohlsman_setting: 30.800000, altitude_fail: 0, vertical_speed: -615.000000, vertical_fail: 0, turn_coordinator_bank: -0.039270, turn_coordinator_ball: -31, plane_heading_magnetic: 6.126106, autopilot_heading_magnetic: 0.310232, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 6.126106, nav1_cdi: -31, nav1_gsi: -31, nav1_to_from: 1, nav1_gs_flag: 1, nav_fail: 0, nav2_available: 0, nav2_obs: 6.126106, nav2_cdi: -31, nav2_to_from: 1, adf1_radial: 6.126106, adf1_card: 6.126106, adf_fail: 0, engine_rpm: 3480, engine_elapsed_time: 9999.000000, engine_instruments_fail: 0, engine_oil_temp: 241.125000, engine_oil_pressure: 120.000000, engine_egt: 1770.000000, engine_fuel_flow: 21.000000, fuel_qty_left_tank: 26.000000, fuel_qty_right_tank: 26.000000, fuel_indicator_fail: 0, vacuum: 6.900000, vacuum_fail: 0, amp: -3.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:1, low_fuel_r:1, low_oil_pressure:1, low_vac_l:1, low_vac_r:1, low_voltage:1},
{ whiskey_compass: 0.000000, ai_pitch: -0.128282, ai_bank: 0.074613, ai_bars_position: -0.200000, caged: 0, ai_fail: 0, indicated_airspeed: 160.000000, airspeed_calibration_angle: -0.094247, airspeed_fail: 0, indicated_altitude: 8200.000000, kohlsman_setting: 30.835000, altitude_fail: 0, vertical_speed: -410.000000, vertical_fail: 0, turn_coordinator_bank: 0.000000, turn_coordinator_ball: -25, plane_heading_magnetic: 0.000000, autopilot_heading_magnetic: 0.157080, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 0.000000, nav1_cdi: -25, nav1_gsi: -25, nav1_to_from: 2, nav1_gs_flag: 1, nav_fail: 0, nav2_available: 0, nav2_obs: 0.000000, nav2_cdi: -25, nav2_to_from: 2, adf1_radial: 0.000000, adf1_card: 0.000000, adf_fail: 0, engine_rpm: 0, engine_elapsed_time: 9999.200000, engine_instruments_fail: 0, engine_oil_temp: 245.000000, engine_oil_pressure: 0.000000, engine_egt: 1800.000000, engine_fuel_flow: 0.000000, fuel_qty_left_tank: 0.000000, fuel_qty_right_tank: 0.000000, fuel_indicator_fail: 0, vacuum: 7.000000, vacuum_fail: 0, amp: 0.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:1, low_fuel_r:1, low_oil_pressure:1, low_vac_l:1, low_vac_r:1, low_voltage:1},
{ whiskey_compass: 0.153153, ai_pitch: -0.026180, ai_bank: 0.227765, ai_bars_position: -0.100000, caged: 0, ai_fail: 0, indicated_airspeed: 170.000000, airspeed_calibration_angle: -0.047124, airspeed_fail: 0, indicated_altitude: 8300.000000, kohlsman_setting: 30.870000, altitude_fail: 0, vertical_speed: -205.000000, vertical_fail: 0, turn_coordinator_bank: 0.039270, turn_coordinator_ball: -19, plane_heading_magnetic: 0.153153, autopilot_heading_magnetic: 6.283185, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 0.153153, nav1_cdi: -19, nav1_gsi: -19, nav1_to_from: 2, nav1_gs_flag: 1, nav_fail: 0, nav2_available: 0, nav2_obs: 0.153153, nav2_cdi: -19, nav2_to_from: 2, adf1_radial: 0.153153, adf1_card: 0.153153, adf_fail: 0, engine_rpm: 87, engine_elapsed_time: 9999.400000, engine_instruments_fail: 0, engine_oil_temp: 90.000000, engine_oil_pressure: 3.000000, engine_egt: 600.000000, engine_fuel_flow: 0.525000, fuel_qty_left_tank: 0.650000, fuel_qty_right_tank: 0.650000, fuel_indicator_fail: 0, vacuum: 3.000000, vacuum_fail: 0, amp: 3.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:1, low_fuel_r:1, low_oil_pressure:1, low_vac_l:1, low_vac_r:1, low_voltage:1},
{ whiskey_compass: 0.306305, ai_pitch: 0.075922, ai_bank: 0.380918, ai_bars_position: -0.000000, caged: 0, ai_fail: 0, indicated_airspeed: 180.000000, airspeed_calibration_angle: -0.000000, airspeed_fail: 0, indicated_altitude: 8400.000000, kohlsman_setting: 30.905000, altitude_fail: 0, vertical_speed: 0.000000, vertical_fail: 0, turn_coordinator_bank: 0.078540, turn_coordinator_ball: -13, plane_heading_magnetic: 0.306305, autopilot_heading_magnetic: 6.130033, gyro_drift_angle: 0.000000, gyro_fail: 0, nav1_available: 0, nav1_obs: 0.306305, nav1_cdi: -13, nav1_gsi: -13, nav1_to_from: 2, nav1_gs_flag: 1, nav_fail: 0, nav2_available: 0, nav2_obs: 0.306305, nav2_cdi: -13, nav2_to_from: 2, adf1_radial: 0.306305, adf1_card: 0.306305, adf_fail: 0, engine_rpm: 174, engine_elapsed_time: 9999.600000, engine_instruments_fail: 0, engine_oil_temp: 93.875000, engine_oil_pressure: 6.000000, engine_egt: 630.000000, engine_fuel_flow: 1.050000, fuel_qty_left_tank: 1.300000, fuel_qty_right_tank: 1.300000, fuel_indicator_fail: 0, vacuum: 3.100000, vacuum_fail: 0, amp: 6.000000, electrical_fail: 0, outside_air_temp: -27.400000, main_bus_voltage: 23.500000, flaps_handle_ratio: 0.000000, flaps_ratio: 0.000000, low_fuel_l:1, low_fuel_r:1, low_oil_pressure:1, low_vac_l:1, low_vac_r:1, low_voltage:1}
];